SystemOrganization addCategory: #'OmniST-Core-Misc'!
SystemOrganization addCategory: #'OmniST-Core-Compiler'!
SystemOrganization addCategory: #'OmniST-Core-Reflection'!

!RBMethodNode methodsFor: '*OmniST-Core-Compiler' stamp: 'StefanMarr 12/3/2011 22:26'!
sourceText
	^source! !

!ContextPart class methodsFor: '*OmniST-Core-Reflection-overrides' stamp: 'StefanMarr 9/6/2012 22:08'!
newForMethod: aMethod
	<omniUnenforced>
	"This is the only method for creating new contexts, other than primitive cloning.
	Any other attempts, such as inherited methods like shallowCopy, should be
	avoided or must at least be rewritten to determine the proper size from the
	method being activated.  This is because asking a context its size (even basicSize!!)
	will not return the real object size but only the number of fields currently
	accessible, as determined by stackp."

	^ super basicNew: aMethod frameSize! !

!ContextPart methodsFor: '*OmniST-Core-Reflection-override' stamp: 'StefanMarr 7/18/2012 21:56'!
canHandleSignal: exception
	"Sent to handler (on:do:) contexts only.  If my exception class (first arg) handles exception then return true, otherwise forward this message to the next handler context.  If none left, return false (see nil>>canHandleSignal:)"

	<omniUnenforced>
	^ (((self tempAt: 1) handles: exception) and: [self tempAt: 3])
		or: [self nextHandlerContext canHandleSignal: exception].
! !

!ContextPart methodsFor: '*OmniST-Core-Reflection-override' stamp: 'StefanMarr 7/18/2012 21:57'!
handleSignal: exception
	"Sent to handler (on:do:) contexts only.  If my exception class (first arg) handles exception then execute my handle block (second arg), otherwise forward this message to the next handler context.  If none left, execute exception's defaultAction (see nil>>handleSignal:)."

	<omniUnenforced>
	| val |
	(((self tempAt: 1) handles: exception) and: [self tempAt: 3]) ifFalse: [
		^ self nextHandlerContext handleSignal: exception].

	exception privHandlerContext: self contextTag.
	self tempAt: 3 put: false.  "disable self while executing handle block"
	val := [(self tempAt: 2) cull: exception]
		ensure: [self tempAt: 3 put: true].
	self return: val.  "return from self if not otherwise directed in handle block"
! !

OrderedCollection subclass: #OstOrderedCollection
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Core-Misc'!

!OstOrderedCollection class methodsFor: 'private' stamp: 'StefanMarr 4/28/2013 22:46'!
arrayType
	^ OstArray! !

!OstOrderedCollection class methodsFor: 'class initialization' stamp: 'StefanMarr 4/28/2013 22:24'!
initialize
	OstObject omnifyClass: self! !

!OstOrderedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstOrderedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/3/2012 14:04'!
omniDomain: aDomain
	omniDomain := aDomain! !

!OstOrderedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector on: self. ]
	! !

!OstOrderedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector lookup: cls
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector lookup: cls on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector lookup: cls on: self. ]
	! !

!OstOrderedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 of: aSelector on: self ]! !

!OstOrderedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1 with: p2
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 with: p2 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 with: p2 of: aSelector on: self ]! !

!OstOrderedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
		! !

!OstOrderedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]! !

!OstOrderedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]! !

!OstOrderedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]! !

!OstOrderedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]! !

!OstOrderedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]! !

!OstOrderedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]! !

!OstOrderedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]! !

!RBOwnedScope methodsFor: '*OmniST-Core-Compiler' stamp: 'StefanMarr 12/9/2011 15:20'!
numOmniTemps
	| parentCount |
	parentCount := owner ifNil:    [0]
	                     ifNotNil: [owner numOmniTemps].
	^ (bindings keys select: [:name | name beginsWith: 'x_omni_']) size + parentCount! !

!RBOwnedScope methodsFor: '*OmniST-Core-Compiler' stamp: 'StefanMarr 12/8/2011 15:19'!
theClass
	^ owner theClass! !

!String methodsFor: '*OmniST-Core-Compiler-overrides' stamp: 'StefanMarr 12/8/2011 21:56'!
numArgs 
	"Answer either the number of arguments that the receiver would take if considered a selector.  Answer -1 if it couldn't be a selector. It is intended mostly for the assistance of spelling correction."

	| firstChar numColons start ix |
	self size = 0 ifTrue: [^ -1].
	self isOmniSelector 
		ifTrue: [ ^ self asNormalSelector numArgs ].
	firstChar := self at: 1.
	(firstChar isLetter or: [ firstChar = $_]) ifTrue:
		["Fast reject if any chars are non-alphanumeric
		NOTE: fast only for Byte things - Broken for Wide"
		self class isBytes
			ifTrue: [(self findSubstring: '~' in: self startingAt: 1 matchTable: Tokenish) > 0 ifTrue: [^ -1]]
			ifFalse: [2 to: self size do: [:i | (self at: i) tokenish ifFalse: [^ -1]]].
		"Fast colon count"
		numColons := 0.  start := 1.
		[(ix := self indexOf: $: startingAt: start) > 0]
			whileTrue:
				[ix = start ifTrue: [^-1].
				numColons := numColons + 1.
				start := ix + 1].
		numColons = 0 ifTrue: [^ 0].
		self last = $:
			ifTrue: [^ numColons]
			ifFalse: [^ -1]].
	firstChar isSpecial ifTrue:
		[self size = 1 ifTrue: [^ 1].
		2 to: self size do: [:i | (self at: i) isSpecial ifFalse: [^ -1]].
		^ 1].
	^ -1.! !

!String methodsFor: '*OmniST-Core-Reflection-override' stamp: 'StefanMarr 12/11/2011 18:48'!
replaceFrom: start to: stop with: replacement startingAt: repStart
	"Primitive. This destructively replaces elements from start to stop in the receiver starting at index, repStart, in the collection, replacement. Answer the receiver. Range checks are performed in the primitive only. Optional. See Object documentation whatIsAPrimitive."
	
	<primitive: 105>
	<omniReplacement: #omniReplaceFrom:to:with:startingAt:>
	super replaceFrom: start to: stop with: replacement startingAt: repStart! !

!MethodNode methodsFor: '*OmniST-Core-Compiler-code generation' stamp: 'StefanMarr 11/28/2011 14:36'!
generate: trailer ifQuick: methodBlock
	| v |
	(primitive = 0 and: [arguments size = 0 and: [block isQuick]])
		ifFalse: [^ self].	
	v := block code.
	v < 0
		ifTrue: [^ self].
	v = LdSelf
		ifTrue: [^ self].
	(v between: LdTrue and: LdMinus1 + 3)
		ifTrue: [^ methodBlock value: (CompiledMethod toReturnConstant: v - LdSelf trailerBytes: trailer)].
	v < ((CodeBases at: LdInstType) + (CodeLimits at: LdInstType))
		ifTrue: [^ self].
	^ self.
	! !

!SmallInteger methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ nil! !

!SmallInteger methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 7/22/2012 00:06'!
omniDomain: aDomain
	^ nil! !

!HashedCollection class methodsFor: '*OmniST-Core-VM-Compat' stamp: 'StefanMarr 4/29/2013 23:24'!
arrayType
	^ Array! !

!HashedCollection methodsFor: '*OmniST-Core-overrides' stamp: 'StefanMarr 4/29/2013 23:28'!
grow
	"Grow the elements array and reinsert the old elements"

	| oldElements |
	oldElements := array.
	array := self class arrayType new: (HashTableSizes atLeast: oldElements size * 2).
	tally := 0.
	oldElements
		do:
			[ :each | 
			each == nil
				ifFalse: [ self noCheckAdd: each ] ]! !

!HashedCollection methodsFor: '*OmniST-Core-overrides' stamp: 'StefanMarr 4/29/2013 23:27'!
growTo: anInteger
	"Grow the elements array and reinsert the old elements"
	
	| oldElements |
	oldElements := array.
	array := self class arrayType new: anInteger.
	self noCheckNoGrowFillFrom: oldElements! !

!HashedCollection methodsFor: '*OmniST-Core-overrides' stamp: 'StefanMarr 4/29/2013 23:27'!
initialize: n
	"Initialize array to an array size of n"
	array := self class arrayType new: n.
	tally := 0! !

!SHParserST80 methodsFor: '*OmniST-Core-Compiler-compatibility' stamp: 'StefanMarr 5/6/2013 23:47'!
parse: isMethodBool
	self initializeInstanceVariables.
	sourcePosition := 1.
	arguments := Dictionary new.
	temporaries := Dictionary new.
	blockDepth := bracketDepth := 0.
	ranges isNil
		ifTrue: [ranges := OrderedCollection new: 100]
		ifFalse: [ranges reset].
	errorBlock := [^ false].
	[self scanNext.
	isMethodBool
		ifTrue: [self parseMessagePattern.
			self parsePragmaSequence].
	self parseMethodTemporaries.
	isMethodBool
		ifTrue: [self parsePragmaSequence].
	self parseStatementList.
	currentToken
		ifNotNil: [self error]]
		ensure: [errorBlock := nil].
	^ true! !

!WriteStream methodsFor: '*OmniST-Core-Reflection-override' stamp: 'StefanMarr 7/29/2012 22:03'!
nextPut: anObject
	"Primitive. Insert the argument at the next position in the Stream
	represented by the receiver. Fail if the collection of this stream is not an
	Array or a String. Fail if the stream is positioned at its end, or if the
	position is out of bounds in the collection. Fail if the argument is not
	of the right type for the collection. Optional. See Object documentation
	whatIsAPrimitive."

	<primitive: 66>
	<omniReplacement: #omniNextPut:>
	((collection class == ByteString) and: [
		anObject isCharacter and:[anObject isOctetCharacter not]]) ifTrue: [
			collection := (WideString from: collection).
			^self nextPut: anObject.
	].
	position >= writeLimit
		ifTrue: [^ self pastEndPut: anObject]
		ifFalse: 
			[position := position + 1.
			^collection at: position put: anObject]! !

!WriteStream methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 12:49'!
omniNextPut: val
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_primNext: self put: val ]
	  ifFalse: [ ^ domain external_primNext: self put: val ]! !

RBCompiler subclass: #OstCompiler
	instanceVariableNames: 'doFullTransformation'
	classVariableNames: 'ErrorOnMissingOmniMethod OldCompiler'
	poolDictionaries: ''
	category: 'OmniST-Core-Compiler'!

!OstCompiler class methodsFor: 'compiler support' stamp: 'StefanMarr 12/15/2011 14:13'!
disableCompiler
	OldCompiler = self ifTrue: [
		RBCompilerDispatcher current: RBCompiler.
	].
	RBCompilerDispatcher current: OldCompiler.! !

!OstCompiler class methodsFor: 'compiler support' stamp: 'StefanMarr 9/12/2012 13:45'!
disableErrorOnMissingOmnifiedMethod
	ErrorOnMissingOmniMethod := false.! !

!OstCompiler class methodsFor: 'compiler support' stamp: 'StefanMarr 12/12/2011 00:52'!
enableCompiler
	| old |
	old := RBCompilerDispatcher current.
	
	"Remember old compiler only if it is not our own."
	old ~= self ifTrue: [
		OldCompiler := old].
	
	RBCompilerDispatcher current: self.! !

!OstCompiler class methodsFor: 'compiler support' stamp: 'StefanMarr 9/12/2012 13:39'!
errorOnMissingOmnifiedMethod
	ErrorOnMissingOmniMethod := true.! !

!OstCompiler class methodsFor: 'compiler support' stamp: 'StefanMarr 12/8/2011 14:54'!
flushAllOmniMethods
	Smalltalk allClassesAndTraits 
		do: [ :ea | ea flushOmniMethods. ea class flushOmniMethods ]
		displayingProgress: 'Flushing Omnified Methods'.! !

!OstCompiler class methodsFor: 'class initialization' stamp: 'StefanMarr 9/12/2012 13:38'!
initialize
	self enableCompiler.
	self registerChangeListener.
	
	(RBMessageNode hasInstVarNamed: #isOmniNode) ifFalse: [
		RBMessageNode addInstVarNamed: #isOmniNode.
	].

	ErrorOnMissingOmniMethod := false.! !

!OstCompiler class methodsFor: 'compiler support' stamp: 'StefanMarr 7/18/2012 21:58'!
installOmniVersionOf: selector in: class
	"Answer the atomic counterpart of aCompiledMethod.
	Methods with the pragma #omniUnenforced are considered to be already omnified.
	Methods with the pragma #omni: will use the annotation code for the omnified counterpart."
	<omniUnenforced>
	| omniCM omniName methDict compiledMethod |

	"Is already atomic do nothing"
	selector isOmniSelector ifTrue: [
		^ class methodDict at: selector ].

	omniName := selector asOmniSelector.
	methDict := class methodDict.
	compiledMethod := class methodDict at: selector.
		
	"These pragmas are specified in OstTransformer>>isOmniTransformationPragma:"
	compiledMethod pragmas do: [ :each |
		each keyword = #omniUnenforced
			ifTrue: [ ^ methDict at: omniName put: compiledMethod ].
			
		each keyword = #omniReplacement:
			ifTrue: [
				| replacementMeth |
				replacementMeth := class lookupSelector: each arguments first.
				omniCM := self installOmniVersionOf: each arguments first in: replacementMeth methodClass.
				^ methDict at: omniName put: omniCM.
			].
	].

	omniCM := self recompileOmnified: compiledMethod.
	^ methDict at: omniName put: omniCM! !

!OstCompiler class methodsFor: 'compiler support' stamp: 'StefanMarr 9/12/2012 13:41'!
omniMethod: aMessage missing: aReceiver in: aClass
	"This method is called whenever a missing atomic method is called. Installs a whole hierarchy of atomic methods."
	<omniUnenforced>
	
	| selector addedAtomicMethod curClass |
	selector := aMessage selector asNormalSelector.
	
	ErrorOnMissingOmniMethod ifTrue: [
		^ (MessageNotUnderstood new
				message: aMessage;
				receiver: self;
				signal)].
	
	ProtoObject withAllSubclasses
		do: [ :class |
		(class methodDictionary includesKey: selector) ifTrue: [
			[self installOmniVersionOf: selector in: class.] value.
			[1 ifError: [:err :rcvr| Transcript cr; show: 'Error while handling a missing omni method. ',
									selector, ' did not compile properly for ', class asString,
									'. Compilation resulted in the following error: ',
									err].].
		]]
	displayingProgress: 'Omnify Methods: ', selector.
! !

!OstCompiler class methodsFor: 'events' stamp: 'StefanMarr 7/18/2012 22:02'!
onMethodModified: anObject
	<omniUnenforced>

	"Ignore the already omnified methods"
	anObject itemSelector isOmniSelector
		ifTrue: [^self].
	
	"Also blacklist a few things"
	((anObject itemClass = Debugger)
	or: [anObject itemClass = Decompiler])
		ifTrue: [^ self].

	"For the rest we do the atomic stuff"	
	self installOmniVersionOf: anObject itemSelector in:  anObject itemClass.! !

!OstCompiler class methodsFor: 'events' stamp: 'StefanMarr 7/18/2012 22:02'!
onMethodRemoved: anObject
	<omniUnenforced>
	
	anObject itemClass methodDict 
		removeKey: anObject itemSelector 
			asOmniSelector
		ifAbsent: nil! !

!OstCompiler class methodsFor: 'compiling' stamp: 'StefanMarr 7/18/2012 22:04'!
recompile: aCompiledMethod
	"Recompile the given method normally"
	<omniUnenforced>
	
	| compiler |
	compiler := self new.
	^ compiler recompile: aCompiledMethod.! !

!OstCompiler class methodsFor: 'compiling' stamp: 'StefanMarr 7/18/2012 22:04'!
recompileOmnified: aCompiledMethod
	"Recompile the given method normally"
	<omniUnenforced>
	
	| compiler |
	compiler := self new.
	^ compiler recompileOmnified: aCompiledMethod.! !

!OstCompiler class methodsFor: 'compiler support' stamp: 'StefanMarr 7/18/2012 22:04'!
recompilePackageWithOstCompiler
	<omniUnenforced>
	
	self enableCompiler.
	self flushAllOmniMethods.

	(PackageInfo named: 'OmniST') classes
		do: [:c | c compileAll]
		displayingProgress: 'Recompiling OmniST with OstCompiler support enabled'.! !

!OstCompiler class methodsFor: 'class initialization' stamp: 'StefanMarr 12/8/2011 14:40'!
registerChangeListener

	SystemChangeNotifier uniqueInstance
		"Currently I only do lazy compilation on first use for new stuff"
		"notify: self ofSystemChangesOfItem: #method change: #Added using: #onMethodAdded:;"
		
		"For existing stuff, however, we need to ensure consistency"
		notify: self ofSystemChangesOfItem: #method change: #Modified using: #onMethodModified:;
		notify: self ofSystemChangesOfItem: #method change: #Removed using: #onMethodRemoved:.! !

!OstCompiler class methodsFor: 'class initialization' stamp: 'StefanMarr 12/9/2011 16:42'!
unload
	self flushAllOmniMethods.
	
	RBMessageNode removeInstVarNamed: #isOmniNode.! !

!OstCompiler class methodsFor: 'class initialization' stamp: 'StefanMarr 12/7/2011 22:11'!
unregisterChangeListener

	SystemChangeNotifier uniqueInstance
		noMoreNotificationsFor: self.! !

!OstCompiler methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/7/2011 22:11'!
initialize
	super initialize.
	doFullTransformation := false.! !

!OstCompiler methodsFor: 'errors' stamp: 'StefanMarr 9/6/2012 20:49'!
notify: aString at: anInteger in: aSource
	Halt once.
	SyntaxErrorNotification
				inClass: class
				category: category
				withCode: (aSource
					copyReplaceFrom: anInteger
					to: anInteger - 1
					with: aString)
				doitFlag: false
				errorMessage: aString
				location: anInteger 
	! !

!OstCompiler methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/7/2011 22:26'!
parse: methodBoolean
	| methodNode transformer |
	methodNode := super parse: methodBoolean.
	
	methodBoolean ifTrue: [
		transformer := OstTransformer new.
		transformer fullTransformation: doFullTransformation.
		transformer applyTransformations: methodNode inScopeOf: class.
	].
	^ methodNode! !

!OstCompiler methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/7/2011 22:14'!
recompile: aCompiledMethod
	"Recompile the given method normally, i.e., with out full STM transformation"

	^ self recompile: aCompiledMethod omnified: false.! !

!OstCompiler methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/11/2011 16:50'!
recompile: aCompiledMethod omnified: aBool
	"Recompile the given method"

	| methodSource newSelector  newMethodNode |
	
	doFullTransformation := aBool.
	
	methodSource := aCompiledMethod getSource.
	newSelector  := aCompiledMethod selector asOmniSelector.
		
	newMethodNode := self
		compile: methodSource in: aCompiledMethod methodClass notifying: self
		ifFail: [^ self problem: 'syntax error' sel: newSelector in: aCompiledMethod methodClass].

	^ newMethodNode generate.! !

!OstCompiler methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/7/2011 22:14'!
recompileOmnified: aCompiledMethod
	"Recompile the given method with the STM enabled"

	^ self recompile: aCompiledMethod omnified: true.! !

!Symbol methodsFor: '*OmniST-Core-Compiler-override' stamp: 'StefanMarr 12/11/2011 16:49'!
precedence
	"Answer the receiver's precedence, assuming it is a valid Smalltalk
	message selector or 0 otherwise.  The numbers are 1 for unary,
	2 for binary and 3 for keyword selectors."

	self isOmniSelector 
		ifTrue: [ ^ self asNormalSelector precedence ].
	self size = 0 ifTrue: [^ 0].
	self first isLetter ifFalse: [^ 2].
	self last = $: ifTrue: [^ 3].
	^ 1! !

Set subclass: #OstSet
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Core-Misc'!

!OstSet class methodsFor: 'private' stamp: 'StefanMarr 4/30/2013 17:47'!
arrayType
	^ OstArray! !

!OstSet class methodsFor: 'private' stamp: 'StefanMarr 4/30/2013 17:46'!
initialize
	OstObject omnifyClass: self.! !

!OstSet methodsFor: 'converting' stamp: 'StefanMarr 4/30/2013 18:04'!
asArray
	"Answer an Array whose elements are the elements of the receiver.
	Implementation note: Cannot use ''Array withAll: self'' as that only
	works for SequenceableCollections which support the replacement 
	primitive."

	| arr index |
	arr := OstArray new: self size.
	index := 0.
	self do: [:each | arr at: (index := index + 1) put: each].
	^ arr! !

!OstSet methodsFor: 'omni reflection' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstSet methodsFor: 'omni reflection' stamp: 'StefanMarr 1/3/2012 14:04'!
omniDomain: aDomain
	omniDomain := aDomain! !

!OstSet methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector on: self. ]
	! !

!OstSet methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector lookup: cls
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector lookup: cls on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector lookup: cls on: self. ]
	! !

!OstSet methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 of: aSelector on: self ]! !

!OstSet methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1 with: p2
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 with: p2 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 with: p2 of: aSelector on: self ]! !

!OstSet methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
		! !

!OstSet methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]! !

!OstSet methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]! !

!OstSet methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]! !

!OstSet methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]! !

!OstSet methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]! !

!OstSet methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]! !

!OstSet methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]! !

SortedCollection subclass: #OstSortedCollection
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Core-Misc'!

!OstSortedCollection class methodsFor: 'private' stamp: 'StefanMarr 4/30/2013 13:14'!
arrayType
	^ OstArray! !

!OstSortedCollection class methodsFor: 'private' stamp: 'StefanMarr 4/30/2013 13:14'!
initialize
	OstObject omnifyClass: self! !

!OstSortedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstSortedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/3/2012 14:04'!
omniDomain: aDomain
	omniDomain := aDomain! !

!OstSortedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector on: self. ]
	! !

!OstSortedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector lookup: cls
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector lookup: cls on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector lookup: cls on: self. ]
	! !

!OstSortedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 of: aSelector on: self ]! !

!OstSortedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1 with: p2
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 with: p2 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 with: p2 of: aSelector on: self ]! !

!OstSortedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
		! !

!OstSortedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]! !

!OstSortedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]! !

!OstSortedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]! !

!OstSortedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]! !

!OstSortedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]! !

!OstSortedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]! !

!OstSortedCollection methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]! !

!Process class methodsFor: '*OmniST-Core-Reflection-overrides' stamp: 'StefanMarr 9/6/2012 21:51'!
forContext: aContext priority: anInteger 
	"Answer an instance of me that has suspended aContext at priority 
	anInteger."
	<omniUnenforced>
	| newProcess |
	newProcess := self new.
	newProcess suspendedContext: aContext.
	newProcess priority: anInteger.
	^newProcess! !

!Process methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 7/18/2012 22:02'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!Process methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 7/18/2012 22:02'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!RBMessageNode methodsFor: '*OmniST-Core-Compiler' stamp: 'StefanMarr 12/8/2011 00:02'!
beOmniNode
	isOmniNode := true.! !

!RBMessageNode methodsFor: '*OmniST-Core-Compiler-inline' stamp: 'JorgeRessia 11/25/2009 13:33'!
isInlineAndOr
	self receiver isBlock ifTrue: [^ false].
	self isCascaded ifTrue: [^ false].
	(self selectorParts allSatisfy: [ :each | #(and: or:) includes: each value ]) 
		ifFalse: [^ false].
	(self arguments allSatisfy: [ :each | each isBlock ])  ifFalse: [^ false].
	(self arguments allSatisfy: [ :each | each arguments isEmpty ])
			ifFalse: [
				self notify: 'and: (or:) takes zero-arg block'.
				^ false ].
	^ true! !

!RBMessageNode methodsFor: '*OmniST-Core-Compiler-inline' stamp: 'jorgeRessia 11/20/2009 16:40'!
isInlineCase

	self isCascaded ifTrue: [^ false].
	(#(caseOf: caseOf:otherwise:) includes: self selector) ifFalse: [^ false].
	self arguments size = 2 ifTrue: [  "otherwise block"
		self arguments last isBlock ifFalse: [^ false]].
	self arguments first isArray ifFalse: [^ false].
	self arguments first statements do: [:assoc |
		(assoc isMessage and: [assoc selector == #->]) ifFalse: [^ false].
		assoc receiver isBlock ifFalse: [^ false].
		assoc receiver arguments isEmpty ifFalse: [self notify: 'caseOf: takes zero-arg blocks'. ^ false].
		assoc arguments first isBlock ifFalse: [^ false].
		assoc arguments first arguments isEmpty ifFalse: [self notify: 'caseOf: takes zero-arg blocks'].
	].
	^ true! !

!RBMessageNode methodsFor: '*OmniST-Core-Compiler-inline' stamp: 'jorgeRessia 11/20/2009 16:40'!
isInlineIf

	self receiver isBlock ifTrue: [^ false].
	self isCascaded ifTrue: [^ false].
	(#(ifTrue: ifFalse: ifTrue:ifFalse: ifFalse:ifTrue:) includes: self selector) ifFalse: [^ false].
	self arguments do: [:node | node isBlock ifFalse: [^ false]].
	self arguments do: [:block |
		block arguments isEmpty ifFalse: [
			self notify: 'ifTrue:ifFalse: takes zero-arg blocks'.
			^ false
		]
	].
	^ true! !

!RBMessageNode methodsFor: '*OmniST-Core-Compiler-inline' stamp: 'MarcusDenker 8/21/2010 13:40'!
isInlineIfNil

	| assertNone assertOneOrNone |
	self receiver isBlock ifTrue: [^ false].
	self isCascaded ifTrue: [^ false].
	(#(ifNil: ifNotNil: ifNil:ifNotNil: ifNotNil:ifNil:) includes: self selector) ifFalse: [^ false].
	self arguments do: [:node | node isBlock ifFalse: [^ false]].
	assertNone := [:block | 
		block arguments isEmpty ifFalse: [self notify: 'ifNil: takes zero-arg block'. ^ false]
	].
	assertOneOrNone := [:block | 
		block arguments size > 1 ifTrue: [self notify: 'ifNotNil: takes zero- or one-arg block'. ^ false]
	].
	self selector caseOf: {
		[#ifNil:] 		 	-> [assertNone value: self arguments first].
		[#ifNil:ifNotNil:] 	-> [assertNone value: self arguments first. 
							   assertOneOrNone value: self arguments last].
		[#ifNotNil:] 		  	-> [assertOneOrNone value: self arguments first].
		[#ifNotNilDo:] 		  	-> [assertOneOrNone value: self arguments first].
		[#ifNotNil:ifNil:] 	-> [assertOneOrNone value: self arguments first. 
							   assertNone value: self arguments last]
	}.
	^ true! !

!RBMessageNode methodsFor: '*OmniST-Core-Compiler-inline' stamp: 'MarcusDenker 9/3/2010 15:03'!
isInlineToDo

	| block step |
	self receiver isBlock ifTrue: [^ false].
	self isCascaded ifTrue: [^ false].
	(#(to:do: to:by:do:) includes: self selector) ifFalse: [^ false].
	self arguments first isBlock ifTrue: [^ false].
	block := self arguments last.
	block isBlock ifFalse: [^ false].
	block arguments size = 1 ifFalse: [
		self notify: 'to:do: block must take one arg'. ^ false].
	(RBParseTreeSearcher new
		matches: block arguments first name , ' := `@object' do: [:n :a | true];
		executeTree: block initialAnswer: false) ifTrue: [^ false].
	self arguments size = 3 "to:by:do:" ifTrue: [
		step := self arguments second.
		step isLiteral ifFalse: [^ false].
		step value = 0 ifTrue: [self notify: 'by: step can''t be zero'. ^ false].
	].
	^ true! !

!RBMessageNode methodsFor: '*OmniST-Core-Compiler-inline' stamp: 'jorgeRessia 11/20/2009 16:40'!
isInlineWhile

	self isCascaded ifTrue: [^ false].
	(#(whileFalse: whileTrue: whileFalse whileTrue) includes: self selector) ifFalse: [^ false].
	self receiver isBlock ifFalse: [^ false].
	self receiver arguments isEmpty ifFalse: [self notify: 'while receiver block must have no arguments'. ^ false].
	self arguments isEmpty ifFalse: [
		self arguments first isBlock ifFalse: [^ false].
		self arguments first arguments isEmpty ifFalse: [self notify: 'while takes a zero-arg block as its argument'. ^ false].
	].
	^ true! !

!RBMessageNode methodsFor: '*OmniST-Core-Compiler-inline' stamp: 'StefanMarr 12/3/2011 14:22'!
isInlined
	^ self isInlineAndOr or:
	 [self isInlineCase  or:
	 [self isInlineIf    or:
	 [self isInlineIfNil or:
	 [self isInlineToDo  or:
	  self isInlineWhile    ]]]]! !

!RBMessageNode methodsFor: '*OmniST-Core-Compiler' stamp: 'StefanMarr 12/8/2011 00:06'!
isOmniNode
	^ isOmniNode = true "with this, we do not need to change initialize"! !

!Behavior methodsFor: '*OmniST-Core-Reflection-override' stamp: 'StefanMarr 12/11/2011 18:10'!
basicNew
	"Primitive. Answer an instance of the receiver (which is a class) with no 
	indexable variables. Fail if the class is indexable. Essential. See Object 
	documentation whatIsAPrimitive."

	<primitive: 70>
	<omniReplacement: #omniBasicNew>
	self isVariable ifTrue: [ ^ self basicNew: 0 ].
	"space must be low"
	OutOfMemory signal.
	^ self basicNew  "retry if user proceeds"! !

!Behavior methodsFor: '*OmniST-Core-Reflection-override' stamp: 'StefanMarr 12/11/2011 18:11'!
basicNew: sizeRequested 
	"Primitive. Answer an instance of this class with the number
	of indexable variables specified by the argument, sizeRequested.
	Fail if this class is not indexable or if the argument is not a
	positive Integer, or if there is not enough memory available. 
	Essential. See Object documentation whatIsAPrimitive."

	<primitive: 71>
	<omniReplacement: #omniBasicNew:>
	self isVariable ifFalse:
		[self error: self printString, ' cannot have variable sized instances'].
	(sizeRequested isInteger and: [sizeRequested >= 0]) ifTrue:
		["arg okay; space must be low."
		OutOfMemory signal.
		^ self basicNew: sizeRequested  "retry if user proceeds"].
	self primitiveFailed! !

!Behavior methodsFor: '*OmniST-Core-Compiler' stamp: 'lr 8/28/2010 11:10'!
compilerClass
	"Answer the compiler class responsible for compiling the methods of this class. Be extremely careful as this method might be called before everything is properly setup."
	
	| class |
	class := Smalltalk
		at: #RBCompilerDispatcher
		ifAbsent: [ ^ Compiler ].
	(class respondsTo: #current)
		ifFalse: [ ^ Compiler ].
	(class current isNil)
		ifTrue: [ ^ Compiler ].
	^ class! !

!Behavior methodsFor: '*OmniST-Core-Compiler' stamp: 'lr 8/28/2010 10:54'!
evaluatorClass
	^ self compilerClass! !

!Behavior methodsFor: '*OmniST-Core-Compiler' stamp: 'StefanMarr 12/8/2011 14:55'!
flushOmniMethods
	| copy |
	self methodDictionary keysDo: [ :each |
		each isOmniSelector ifTrue: [
			copy := copy ifNil: [ self methodDictionary copy ].
			copy removeDangerouslyKey: each ifAbsent: [] ] ].
	copy ifNotNil: [ self methodDictionary become: copy ]! !

!Behavior methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 7/18/2012 22:01'!
omniBasicNew
	| obj |
	<omniUnenforced>
	obj := self basicNew.
	OstDomain initializeDomainForNewObject: obj of: self.
	^ obj! !

!Behavior methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 7/18/2012 22:01'!
omniBasicNew: sizeRequested 
	"This is the omni-fied implementation.
	 The original basicNew: is now rawBasicNew:."
	<omniUnenforced>
	
	| obj |
	obj := self basicNew: sizeRequested.
	OstDomain initializeDomainForNewObject: obj of: self.
	^ obj! !

!Behavior methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 4/27/2013 19:25'!
omniDomain
	"We consider these classes, i.e., their objects, metaobjects so that their are not owned by
	 any specific domain."
	<omniUnenforced>
	^ nil! !

!Behavior methodsFor: '*OmniST-Core-Compiler' stamp: 'StefanMarr 12/9/2011 17:08'!
omniMethods
	^ Array streamContents: [ :stream |
		self methodDictionary keysAndValuesDo: [ :key :value |
			key isOmniSelector 
				ifTrue: [ stream nextPut: value ] ] ]! !

!Behavior methodsFor: '*OmniST-Core-Compiler' stamp: 'StefanMarr 12/9/2011 17:05'!
selectors
	"Answer a Set of all the message selectors specified in the receiver's 
	method dictionary."

	^ self methodDict keys reject: [ :each | each isOmniSelector ]! !

!Behavior methodsFor: '*OmniST-Core-Compiler' stamp: 'StefanMarr 12/9/2011 17:05'!
selectorsAndMethodsDo: aBlock
	"Evaluate selectorBlock for all the message selectors in my method dictionary."

	^ self methodDict keysAndValuesDo: [ :selector :method |
		selector isOmniSelector 
			ifFalse: [ aBlock value: selector value: method ] ]! !

!Behavior methodsFor: '*OmniST-Core-Compiler' stamp: 'StefanMarr 12/9/2011 17:05'!
selectorsDo: selectorBlock
	"Evaluate selectorBlock for all the message selectors in my method dictionary."

	^ self methodDict keysDo: [ :selector |
		selector isOmniSelector 
			ifFalse: [ selectorBlock value: selector ] ]! !

!MethodContext methodsFor: '*OmniST-Core-Reflection-override' stamp: 'StefanMarr 7/18/2012 22:08'!
tempAt: index 
	"Answer the value of the temporary variable whose index is the 
	 argument, index.  Primitive. Assumes receiver is indexable. Answer the
	 value of an indexable element in the receiver. Fail if the argument index
	 is not an Integer or is out of bounds. Essential. See Object documentation
	 whatIsAPrimitive.  Override the default at: primitive to give latitude to the
	 VM in context management."
	
	<omniUnenforced>
	<primitive: 210>
	^self at: index! !

!MethodContext methodsFor: '*OmniST-Core-Reflection-override' stamp: 'StefanMarr 7/18/2012 22:07'!
tempAt: index put: value 
	"Store the argument, value, as the temporary variable whose index is the 
	 argument, index.  Primitive. Assumes receiver is indexable. Answer the
	 value of an indexable element in the receiver. Fail if the argument index
	 is not an Integer or is out of bounds. Essential. See Object documentation
	 whatIsAPrimitive.  Override the default at:put: primitive to give latitude to
	 the VM in context management."

	<omniUnenforced>
	<primitive: 211>
	^self at: index put: value! !

RBSemanticAnnotator subclass: #OstTransformer
	instanceVariableNames: 'doFullTransformation doLocalTransformation numOfOmniTemps'
	classVariableNames: 'RequestExecutionSelectors RequestSuperExecutionSelectors'
	poolDictionaries: ''
	category: 'OmniST-Core-Compiler'!

!OstTransformer commentStamp: '<historical>' prior: 0!
OmniTransformer iterates over the AST of a method to transform it.
The goal is to delegate all read, write, and message-send operations via a domain object.!

!OstTransformer class methodsFor: 'initialization' stamp: 'StefanMarr 3/20/2012 17:48'!
generateRequestExecutionSelectors
	| sel max |
	max := 15.
	sel := #requestExecutionOf:.
	RequestExecutionSelectors := Array new: max.
	1 to: max do: [:i |
		RequestExecutionSelectors at: i put: sel.
		sel := (sel, #with:) asSymbol.
	].

	sel := #requestExecutionOf:lookup:.
	RequestSuperExecutionSelectors := Array new: max.
	1 to: max do: [:i |
		RequestSuperExecutionSelectors at: i put: sel.
		sel := (sel, #with:) asSymbol.
	].! !

!OstTransformer class methodsFor: 'initialization' stamp: 'StefanMarr 12/8/2011 00:58'!
initialize
	self generateRequestExecutionSelectors.! !

!OstTransformer methodsFor: 'visitor-double dispatching' stamp: 'StefanMarr 12/7/2011 20:49'!
acceptAssignmentNode: anAssignmentNode
	super acceptAssignmentNode: anAssignmentNode.
	
	self doTransformation ifFalse: [^self].
	
	(anAssignmentNode variable isInstanceBinding or:
	[anAssignmentNode variable isLiteralBinding "or: REMOTE NOT YET SUPPORTED
	[anAssignmentNode variable isRemote]"]) ifTrue: [
		| replacement |
		replacement := self createOmniAssignment: anAssignmentNode.
		anAssignmentNode parent replaceNode: anAssignmentNode withNode: replacement.
	]! !

!OstTransformer methodsFor: 'visitor-double dispatching' stamp: 'StefanMarr 12/8/2011 15:39'!
acceptMessageNode: aMessageNode
	| doLocalTransformationOld replacement |
	doLocalTransformationOld := doLocalTransformation.
	
	doLocalTransformation := doLocalTransformation or: [self isOmniEntryMessage: aMessageNode selector].

	(self doTransformation and: [aMessageNode isInlined not])
		ifTrue:  [self  transformMessageNode: aMessageNode.]
		ifFalse: [super acceptMessageNode:    aMessageNode.].

	doLocalTransformation := doLocalTransformationOld.! !

!OstTransformer methodsFor: 'visitor-dispatching' stamp: 'StefanMarr 12/7/2011 20:55'!
acceptMethodNode: aMethodNode
	super acceptMethodNode: aMethodNode.
	doFullTransformation ifTrue: [
		aMethodNode selector: (aMethodNode selector asOmniSelector)
	].! !

!OstTransformer methodsFor: 'initialize-release' stamp: 'StefanMarr 1/2/2012 18:38'!
acceptOmniEntryNode: aMessageNode
	(self omniEntryBlockIsReceiver: aMessageNode selector)
		ifTrue: [
			"Then we do not do a full processing, but are skipping the arguments"
			(aMessageNode isCascaded not or: [aMessageNode isFirstCascaded]) 
					ifTrue: [self visitNode: aMessageNode receiver].]
		ifFalse:[
			"If the block to be omnified is the argument however, we do transform it."
			aMessageNode arguments do: [:each | self visitNode: each]]! !

!OstTransformer methodsFor: 'visitor-dispatching' stamp: 'StefanMarr 12/8/2011 00:56'!
acceptVariableNode: aVariableNode
	| replacement |
	self doTransformation ifFalse: [^self].
	
	super acceptVariableNode: aVariableNode.
	
	"Not every variable node we are going to encounter is a read.
	 Make sure it is not the variable node of a parent assignment node.
	 Furthermore, we do not need to take care of temp assignments.
	 Only globals, instances, and perhaps remote onces of a closure."
	(aVariableNode isRead
	 and: [aVariableNode isLiteralBinding   or: 
		   [aVariableNode isInstanceBinding "or: REMOTES NOT SUPPORTED at the moment
			[aVariableNode isRemote]"]])
		ifFalse: [^self].
	
	"Now we are sure that we have to transform a variable read".
	replacement := self createOmniReadNode: aVariableNode.
	aVariableNode parent replaceNode: aVariableNode withNode: replacement. 
! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 8/2/2012 11:18'!
applyTransformations: methodNode inScopeOf: aClass
	"We have two cases:
	   Either it is a normal method, and we do only the omni blocks,
	   or it is a fully omni method and we transform everything.
	
	 doFullTransformation indicates that we do not only local adaptations.
	"
	| classScope |
	(self pragmasForbidTransformation: methodNode)
		ifTrue: [^self].
	(self pragmasForbidFullTransformation: methodNode)
		ifTrue: [doFullTransformation := false].
	
	classScope := RBVariableScope
							owner: (RBLiteralScope 	owner: RBRootScope new class: aClass)
							class: aClass.
	
	self start: methodNode scope: classScope.! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 1/29/2013 21:03'!
createObtainCurrentOmniDomainNode
	| msgSendNode  |
	msgSendNode := RBMessageNode
						  receiver: (RBMessageNode receiver: (RBLiteralValueNode value: Processor)
						                         selector: #activeProcess)
						  selector: #omniDomain.
	msgSendNode beOmniNode.
	^ msgSendNode.! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 7/21/2012 18:51'!
createObtainSelfOmniDomainNode
	| msgSendNode  |
	msgSendNode := RBMessageNode receiver: self createSelfRefNode
									   selector: #omniDomain.
	msgSendNode beOmniNode.
	^ msgSendNode.! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 7/18/2012 21:47'!
createOmniAssignment: anAssignmentNode
	| var |
	var := anAssignmentNode variable.
	var isInstanceBinding ifTrue: [
		^ self createWriteMessageSendFor: var with: anAssignmentNode value.
	]
	ifFalse: [
		| globalAssoc sendArgs |
		var isLiteralBinding ifFalse: [self halt: 'I guess we still need to implement something, e.g., remote vars.'].
		
		^ self createWriteGlobalMessageSendFor: var with: anAssignmentNode value.
	].! !

!OstTransformer methodsFor: 'visitor-double dispatching' stamp: 'StefanMarr 7/21/2012 18:52'!
createOmniDomainRefNode
	"Return a node that will resolve at runtime to the omni domain object,
	 or in case the class does not have a slot called omniDomain, resolve to
	 the nil object"
	| omniIdx omniRef |
	omniIdx := OstDomain domainIndexFromClass: scope theClass.
	omniIdx = 0
		ifTrue: [
			"The class does not have a omniDomain slot"
			"What to do now?
			 For the moment, we will do `self omniDomain`"
			omniRef := self createObtainSelfOmniDomainNode.
		]
		ifFalse:[
			"This class got a omniDomain slot"
			omniRef := RBVariableNode named: #omniDomain.
			omniRef variableBinding: (scope lookup: #omniDomain).
		].
	
	^ omniRef! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 12/15/2011 14:25'!
createOmniMessageNode: aMessageNode
	| omniSel |

	omniSel := aMessageNode selector asOmniSelector.
	
	^ self createRequestExecutionNodeOn: aMessageNode receiver
										 with: omniSel
										  and: aMessageNode arguments.
! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 12/9/2011 15:50'!
createOmniReadNode: aVariableNode
	| selfRef omniDomainRef instIdx sendArgs |
	
	aVariableNode isInstanceBinding ifTrue: [
		^ self createReadMessageSendFor: aVariableNode.
	]
	ifFalse: [
		aVariableNode isLiteralBinding
			ifFalse: [self halt: 'I guess we still need to implement something, e.g., remote vars.'].
		^ self createReadGlobalMessageSendFor: aVariableNode.
	].
	! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 1/29/2013 21:04'!
createReadGlobalMessageSendFor: aVariableNode
	| globalAssoc args sendNode |

	globalAssoc := RBLiteralValueNode value: aVariableNode variableBinding binding.
		
	args := OrderedCollection new: 1.
	args add: globalAssoc.
		
	sendNode := RBMessageNode receiver: self createObtainCurrentOmniDomainNode
		                          selector: #internal_readLiteral:
		                          arguments: args.
	sendNode beOmniNode.
	^ sendNode! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 12/8/2011 01:21'!
createReadMessageSendFor: aVariableNode
	| selfRef omniDomainRef instIdx sendArgs readNode |
	selfRef := self createSelfRefNode.
	omniDomainRef := self createOmniDomainRefNode.
	
	instIdx  := RBLiteralValueNode value: (aVariableNode variableBinding index).
	sendArgs := OrderedCollection new: 2.
	sendArgs add: instIdx.
	sendArgs add: selfRef.
	readNode := RBMessageNode receiver: omniDomainRef selector: #readField:of: arguments: sendArgs.
	readNode beOmniNode.
	^ readNode
! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 3/20/2012 17:38'!
createRequestExecutionNodeOn: receiver with: selector and: arguments
	| msgSendNode reqExecSelector msgArguments numArgs isSuperSend newRcvr |
	
	"REM: we send to self, to avoid more complex rewrites
	  #requestExecutionOf:with:...   or   #requestExecutionOf:lookup:with:..."
	numArgs := selector numArgs.

	isSuperSend := receiver isVariable
						ifTrue:  [receiver variableBinding isSuperBinding]
						ifFalse: [false].
	newRcvr := isSuperSend ifTrue: [self createSelfRefNode]
								ifFalse:[receiver].

	reqExecSelector := self requestExecutionSelectorFor: numArgs withSuper: isSuperSend.
	
	"One extra argument for the class where the lookup starts."
	isSuperSend ifTrue: [ numArgs := numArgs + 1. ].
	
	"And another argument for the selector"
	numArgs := numArgs + 1.
	
	msgArguments := OrderedCollection new: numArgs.
	msgArguments add: (RBLiteralValueNode value: selector).
	isSuperSend ifTrue: [
		msgArguments add: (RBLiteralValueNode value: scope theClass superclass).
	].
	msgArguments addAll: arguments.
	
	msgSendNode := RBMessageNode receiver:  newRcvr
								      selector:  reqExecSelector
								      arguments: msgArguments.
	msgSendNode beOmniNode.
	^ msgSendNode! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 12/8/2011 01:11'!
createSelfRefNode
	| selfRef |
	selfRef := RBVariableNode named: 'self'.
	selfRef variableBinding: (scope lookup: 'self').
	^ selfRef! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 1/29/2013 21:04'!
createWriteGlobalMessageSendFor: aVariableNode with: valueNode
	| globalAssoc args sendNode |

	globalAssoc := RBLiteralValueNode value: aVariableNode variableBinding binding.
		
	args := OrderedCollection new: 2.
	args add: valueNode.
	args add: globalAssoc.
		
	sendNode := RBMessageNode receiver: self createObtainCurrentOmniDomainNode
		                          selector: #internal_write:toLiteral:
		                          arguments: args.
	sendNode beOmniNode.
	^ sendNode! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 12/8/2011 21:57'!
createWriteMessageSendFor: aVarNode with: aValue
		| selfRef omniDomainRef instIdx sendArgs sendNode |
		selfRef := self createSelfRefNode.
		omniDomainRef := self createOmniDomainRefNode.
		
		instIdx := RBLiteralValueNode value: (aVarNode variableBinding index).
		
		sendArgs := OrderedCollection new: 3.
		sendArgs add: aValue.
		sendArgs add: instIdx.
		sendArgs add: selfRef.
		
		sendNode := RBMessageNode receiver: omniDomainRef
									   selector: #write:toField:of:
									   arguments: sendArgs.
		sendNode beOmniNode.
		^ sendNode
! !

!OstTransformer methodsFor: 'testing' stamp: 'StefanMarr 12/7/2011 20:35'!
doTransformation
	^ doFullTransformation or: [doLocalTransformation]! !

!OstTransformer methodsFor: 'accessing' stamp: 'StefanMarr 12/7/2011 20:35'!
fullTransformation: aBool
	doFullTransformation := aBool! !

!OstTransformer methodsFor: 'initialize-release' stamp: 'StefanMarr 12/9/2011 15:29'!
initialize
	super initialize.
	doFullTransformation  := false.
	doLocalTransformation := false.
	numOfOmniTemps := 0.
! !

!OstTransformer methodsFor: 'visitor-double dispatching' stamp: 'StefanMarr 1/3/2012 11:22'!
isOmniEntryMessage: aSelector
	^ aSelector = #omni            or: [
	  aSelector = #omni:           or: [
	  aSelector = #atomic          or: [
	  aSelector = #evaluateAsync:  or: [
	  aSelector = #newWithInitializer:
	]]]].! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 12/9/2011 15:29'!
nextOmniTempIdx
	"Creates a sequence of unique id numbers for a method transformation to name the temporary variables"
	numOfOmniTemps := numOfOmniTemps + 1.
	^ numOfOmniTemps! !

!OstTransformer methodsFor: 'initialize-release' stamp: 'StefanMarr 1/3/2012 11:21'!
omniEntryBlockIsReceiver: aSelector
	(aSelector = #omni            or: [
	 aSelector = #omni:           or: [
	 aSelector = #atomic]])
		ifTrue: [^true].
		
	(aSelector = #evaluateAsync:  or: [
	 aSelector = #newWithInitializer:])
		ifTrue: [^ false].
	

	"Else"
	'This selector is not currently known' halt.! !

!OstTransformer methodsFor: 'testing' stamp: 'StefanMarr 8/2/2012 11:18'!
pragmasForbidFullTransformation: methodNode
	"The #omniUnenforced pragma forbids full transformation, but allows partial transformation"
	
	methodNode pragmas do: [:each |
		(#omniUnenforced = each selector)
			ifTrue: [^true].
	].
	^false.! !

!OstTransformer methodsFor: 'testing' stamp: 'StefanMarr 8/2/2012 11:18'!
pragmasForbidTransformation: methodNode
	"Some of our pragmas restrict the boundaries of the Omni execution layer.
	 They enable to break out into the implementation level."
	methodNode pragmas do: [:each |
		(#omniReplacement: = each selector)
			ifTrue: [^true].
	].
	^false.! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 1/2/2012 18:07'!
requestExecutionSelectorFor: nArgs withSuper: superSend
	(nArgs >= 0 and: [nArgs < RequestSuperExecutionSelectors size])
		ifTrue: [
			superSend
				ifTrue: [^ RequestSuperExecutionSelectors at: nArgs + 1.]
				ifFalse:[^ RequestExecutionSelectors at: nArgs + 1.]
		]
		ifFalse: [
			self halt: 'This is currently not implemented!! ',
			           'Need either to extend this table/array, ',
			           'or make a distinction to use the other primitive (84) which accepts an array.'.
		].
	^ nil! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 1/2/2012 18:37'!
transformMessageNode: aMessageNode
	(doFullTransformation or: [(self isOmniEntryMessage: aMessageNode selector) not])
		ifTrue: [ super acceptMessageNode: aMessageNode. ]
		ifFalse:[
			"This is the case if it is the omni entry node."
			self acceptOmniEntryNode: aMessageNode.
		].

	((self isOmniEntryMessage: aMessageNode selector) or: [
	 aMessageNode isInlined or: [
	 aMessageNode isOmniNode or: [
	 aMessageNode receiver isLiteral ]]]) "REM: added optimization for literal nodes here, we do not omnify those"
		ifFalse: [
			| replacement |
			replacement := self createOmniMessageNode: aMessageNode.
			aMessageNode parent replaceNode: aMessageNode withNode: replacement.
		].! !

!Encoder methodsFor: '*OmniST-Core-Compiler-compatibility' stamp: 'StefanMarr 5/7/2013 20:40'!
encodeSelector: aSelector

	^self
		name: aSelector
		key: aSelector
		class: SelectorNode
		type: SendType
		set: selectorSet! !

!Dictionary methodsFor: '*OmniST-Core-overrides' stamp: 'StefanMarr 4/29/2013 23:25'!
associations
	"Answer a Collection containing the receiver's associations."
	"Suggested by l. Uzonyi"
	
	^ self class arrayType new: self size streamContents: [ :stream |
		self associationsDo: [ :each | stream nextPut: each ] ]! !

!Dictionary methodsFor: '*OmniST-Core-overrides' stamp: 'StefanMarr 4/29/2013 23:25'!
keys
	"Answer an Array containing the receiver's keys."
	
	^ self class arrayType new: self size streamContents: [:s| self keysDo: [:key| s nextPut: key]]! !

!Dictionary methodsFor: '*OmniST-Core-overrides' stamp: 'StefanMarr 4/29/2013 23:26'!
keysSortedSafely
	"Answer an Array containing the receiver's keys."
 	"Suggested by l. Uzonyi"
	
 	| sortedKeys |
 	sortedKeys := self class arrayType 
						new: self size 
						streamContents: [ :stream |
 								self keysDo: [ :each | stream nextPut: each ] ].
 	sortedKeys sort: [ :x :y |
 		"Should really be use <obj, string, num> compareSafely..."
 		((x isString and: [ y isString ])
 			or: [ x isNumber and: [ y isNumber ] ])
 			ifTrue: [ x < y ]
 			ifFalse: [ x class == y class
 				ifTrue: [ x printString < y printString ]
 				ifFalse: [ x class name < y class name ] ] ].
 	^sortedKeys! !

!Dictionary methodsFor: '*OmniST-Core-overrides' stamp: 'StefanMarr 4/29/2013 23:26'!
values
	"Answer a Collection containing the receiver's values."
	| out |
	out := (self class arrayType new: self size) writeStream.
	self valuesDo: [:value | out nextPut: value].
	^ out contents! !

Dictionary subclass: #OstDictionary
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Core-Misc'!

!OstDictionary class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/29/2013 23:29'!
arrayType
	^ OstArray! !

!OstDictionary class methodsFor: 'class initialization' stamp: 'StefanMarr 4/29/2013 23:29'!
initialize
	OstObject omnifyClass: self! !

!OstDictionary methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/30/2013 13:24'!
at: key put: anObject 
	"Set the value at key to be anObject.  If key is not found, create a
	new entry for key and set is value to anObject. Answer anObject."

	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	assoc
		ifNil: [self atNewIndex: index put: (OstAssociation key: key value: anObject)]
		ifNotNil: [assoc value: anObject].
	^ anObject! !

!OstDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/3/2012 14:04'!
omniDomain: aDomain
	omniDomain := aDomain! !

!OstDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector on: self. ]
	! !

!OstDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector lookup: cls
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector lookup: cls on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector lookup: cls on: self. ]
	! !

!OstDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 of: aSelector on: self ]! !

!OstDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1 with: p2
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 with: p2 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 with: p2 of: aSelector on: self ]! !

!OstDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
		! !

!OstDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]! !

!OstDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]! !

!OstDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]! !

!OstDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]! !

!OstDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]! !

!OstDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]! !

!OstDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]! !

!RBVariableNode methodsFor: '*OmniST-Core-Compiler-ast-semantic-accessing' stamp: 'StefanMarr 12/4/2011 15:20'!
isInstanceBinding
	^ self variableBinding isInstanceBinding! !

!RBVariableNode methodsFor: '*OmniST-Core-Compiler-ast-semantic-accessing' stamp: 'StefanMarr 12/4/2011 15:27'!
isLiteralBinding
	^ self variableBinding isLiteralBinding! !

!RBVariableNode methodsFor: '*OmniST-Core-Compiler-ast-semantic-accessing' stamp: 'StefanMarr 12/4/2011 15:49'!
variableBinding: aBinding
	^ self propertyAt: #variableBinding put: aBinding! !

!TPureBehavior methodsFor: '*OmniST-Core-Compiler' stamp: 'StefanMarr 12/8/2011 14:58'!
flushOmniMethods
	| copy |
	self methodDictionary keysDo: [ :each |
		each isOmniSelector ifTrue: [
			copy := copy ifNil: [ self methodDictionary copy ].
			copy removeDangerouslyKey: each ifAbsent: [] ] ].
	copy ifNotNil: [ self methodDictionary become: copy ]! !

!TPureBehavior methodsFor: '*OmniST-Core-Compiler' stamp: 'StefanMarr 12/11/2011 16:44'!
selectors
	"Answer a Set of all the message selectors specified in the receiver's 
	method dictionary."

	^ self methodDict keys reject: [ :each | each isOmniSelector ]! !

!TPureBehavior methodsFor: '*OmniST-Core-Compiler' stamp: 'StefanMarr 12/11/2011 16:44'!
selectorsAndMethodsDo: aBlock
	"Evaluate selectorBlock for all the message selectors in my method dictionary."

	^ self methodDict keysAndValuesDo: [ :selector :method |
		selector isOmniSelector 
			ifFalse: [ aBlock value: selector value: method ] ]! !

!TPureBehavior methodsFor: '*OmniST-Core-Compiler' stamp: 'StefanMarr 12/11/2011 16:44'!
selectorsDo: selectorBlock
	"Evaluate selectorBlock for all the message selectors in my method dictionary."

	^ self methodDict keysDo: [ :selector |
		selector isOmniSelector 
			ifFalse: [ selectorBlock value: selector ] ]! !

!HashTableSizes class methodsFor: '*OmniST-Core-Reflection-overrides' stamp: 'StefanMarr 4/30/2013 17:38'!
atLeast: lowerLimit
	"This is a helper that is considered immutable, and we make it unenforced as a performance optimization"
	<omniUnenforced>
	"Answer the next good size >= lowerlimit.
	If lowerLimit is larger than the largest known good prime,
	just make it odd."

	| primes low mid high prime |
	primes := self sizes.
	low := 1.
	high := primes size.
	lowerLimit > (primes at: high)
		ifTrue:
			[ ^ lowerLimit even
				ifTrue: [ lowerLimit + 1 ]
				ifFalse: [ lowerLimit ] ].
	[ mid := (high - low) // 2 + low.
	prime := primes at: mid.
	prime < lowerLimit
		ifTrue: [ low := mid ]
		ifFalse: [ high := mid ].
	high - low <= 1
		ifTrue: [ ^ primes at: high ] ] repeat! !

!HashTableSizes methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 4/30/2013 13:36'!
omniDomain
	"we consider it an immutable object"
	<omniUnenforced>
	^ nil! !

!BlockContext methodsFor: '*OmniST-Core-Reflection-override' stamp: 'StefanMarr 7/18/2012 22:08'!
tempAt: index 
	"Refer to the comment in ContextPart|tempAt:."

	<omniUnenforced>
	^ home at: index! !

!BlockContext methodsFor: '*OmniST-Core-Reflection-override' stamp: 'StefanMarr 7/18/2012 22:07'!
tempAt: index put: value 
	"Refer to the comment in ContextPart|tempAt:put:."

	<omniUnenforced>
	^ home at: index put: value! !

Association subclass: #OstAssociation
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Core-Misc'!

!OstAssociation class methodsFor: 'class initialization' stamp: 'StefanMarr 4/30/2013 13:23'!
initialize
	OstObject omnifyClass: self.! !

!OstAssociation methodsFor: 'omni reflection' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstAssociation methodsFor: 'omni reflection' stamp: 'StefanMarr 1/3/2012 14:04'!
omniDomain: aDomain
	omniDomain := aDomain! !

!OstAssociation methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector on: self. ]
	! !

!OstAssociation methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector lookup: cls
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector lookup: cls on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector lookup: cls on: self. ]
	! !

!OstAssociation methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 of: aSelector on: self ]! !

!OstAssociation methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1 with: p2
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 with: p2 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 with: p2 of: aSelector on: self ]! !

!OstAssociation methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
		! !

!OstAssociation methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]! !

!OstAssociation methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]! !

!OstAssociation methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]! !

!OstAssociation methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]! !

!OstAssociation methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]! !

!OstAssociation methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]! !

!OstAssociation methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]! !

Point subclass: #OstPoint
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Core-Misc'!

!OstPoint class methodsFor: 'class initialization' stamp: 'StefanMarr 5/7/2013 19:26'!
initialize
	OstObject omnifyClass: self.! !

!OstPoint methodsFor: 'omni reflection' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstPoint methodsFor: 'omni reflection' stamp: 'StefanMarr 1/3/2012 14:04'!
omniDomain: aDomain
	omniDomain := aDomain! !

!OstPoint methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector on: self. ]
	! !

!OstPoint methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector lookup: cls
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector lookup: cls on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector lookup: cls on: self. ]
	! !

!OstPoint methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 of: aSelector on: self ]! !

!OstPoint methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1 with: p2
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 with: p2 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 with: p2 of: aSelector on: self ]! !

!OstPoint methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
		! !

!OstPoint methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]! !

!OstPoint methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]! !

!OstPoint methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]! !

!OstPoint methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]! !

!OstPoint methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]! !

!OstPoint methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]! !

!OstPoint methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]! !

Rectangle subclass: #OstRectangle
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Core-Misc'!

!OstRectangle class methodsFor: 'class initialization' stamp: 'StefanMarr 5/7/2013 18:16'!
initialize
	OstObject omnifyClass: self! !

!OstRectangle methodsFor: 'rectangle functions' stamp: 'StefanMarr 5/7/2013 20:26'!
intersect: aRectangle 
	"Answer a Rectangle that is the area in which the receiver overlaps with 
	aRectangle. Optimized for speed; old code read:
		^Rectangle 
			origin: (origin max: aRectangle origin)
			corner: (corner min: aRectangle corner)
	"
	| aPoint left right top bottom |
	aPoint := aRectangle origin.
	aPoint x > origin x 
		ifTrue: [ left := aPoint x ]
		ifFalse: [ left := origin x ].
	aPoint y > origin y 
		ifTrue: [ top := aPoint y ]
		ifFalse: [ top := origin y ].
	aPoint := aRectangle corner.
	aPoint x < corner x 
		ifTrue: [ right := aPoint x ]
		ifFalse: [ right := corner x ].
	aPoint y < corner y 
		ifTrue: [ bottom := aPoint y ]
		ifFalse: [ bottom := corner y ].
	^ OstRectangle 
		origin: (OstPoint x: left y: top)
		corner: (OstPoint x: right y: bottom)! !

!OstRectangle methodsFor: 'omni reflection' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstRectangle methodsFor: 'omni reflection' stamp: 'StefanMarr 1/3/2012 14:04'!
omniDomain: aDomain
	omniDomain := aDomain! !

!OstRectangle methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector on: self. ]
	! !

!OstRectangle methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector lookup: cls
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector lookup: cls on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector lookup: cls on: self. ]
	! !

!OstRectangle methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 of: aSelector on: self ]! !

!OstRectangle methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1 with: p2
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 with: p2 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 with: p2 of: aSelector on: self ]! !

!OstRectangle methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
		! !

!OstRectangle methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]! !

!OstRectangle methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]! !

!OstRectangle methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]! !

!OstRectangle methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]! !

!OstRectangle methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]! !

!OstRectangle methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]! !

!OstRectangle methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]! !

!LeafNode methodsFor: '*OmniST-Core-Compiler-compatibility' stamp: 'StefanMarr 5/7/2013 20:37'!
code: anIndex type: aType

	anIndex isNil 
		ifTrue: [^aType negated].
	(CodeLimits at: aType) > anIndex 
		ifTrue: [^(CodeBases at: aType) + anIndex].
	^aType * 256 + anIndex! !

Monitor subclass: #OstMonitor
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Core-Misc'!

!OstMonitor class methodsFor: 'class initialization' stamp: 'StefanMarr 4/29/2013 21:45'!
initialize
	OstObject omnifyClass: self! !

!OstMonitor methodsFor: 'private' stamp: 'StefanMarr 4/29/2013 21:46'!
defaultQueue
	defaultQueue ifNil: [defaultQueue := OstOrderedCollection new].
	^ defaultQueue! !

!OstMonitor methodsFor: 'omni reflection' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstMonitor methodsFor: 'omni reflection' stamp: 'StefanMarr 1/3/2012 14:04'!
omniDomain: aDomain
	omniDomain := aDomain! !

!OstMonitor methodsFor: 'private' stamp: 'StefanMarr 4/29/2013 23:58'!
queueDict
	^ queueDict ifNil: [queueDict := OstIdentityDictionary new].! !

!OstMonitor methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector on: self. ]
	! !

!OstMonitor methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector lookup: cls
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector lookup: cls on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector lookup: cls on: self. ]
	! !

!OstMonitor methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 of: aSelector on: self ]! !

!OstMonitor methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1 with: p2
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 with: p2 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 with: p2 of: aSelector on: self ]! !

!OstMonitor methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
		! !

!OstMonitor methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]! !

!OstMonitor methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]! !

!OstMonitor methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]! !

!OstMonitor methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]! !

!OstMonitor methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]! !

!OstMonitor methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]! !

!OstMonitor methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]! !

!Float methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 4/27/2013 19:37'!
omniDomain
	"floats are considered immutable, we don't need a domain for them"
	<omniUnenforced>
	^ nil! !

!Float methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 4/27/2013 19:38'!
omniDomain: aDomain
	"floats are considered immutable, we don't need a domain for them"
	<omniUnenforced>! !

!BlockClosure methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 12/15/2011 15:07'!
omni
	^ OstDomain new evaluateInContext: self.! !

!BlockClosure methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 12/8/2011 16:01'!
omni: aDomain
	^ aDomain evaluateInContext: self.! !

!BlockClosure methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 4/28/2013 22:51'!
omniDomain
	"we treat them as immutable metaobjects..."
	<omniUnenforced>
	^ nil! !

!Exception methodsFor: '*OmniST-Core-Reflection-override' stamp: 'StefanMarr 7/18/2012 22:08'!
resumeUnchecked: resumptionValue
	"Return resumptionValue as the value of #signal, unless this was called after an #outer message, then return resumptionValue as the value of #outer."
	<omniUnenforced>
	| ctxt |
	outerContext 
		ifNil: [
			signalContext return: resumptionValue ] 
		ifNotNil: [
			ctxt := outerContext.
			outerContext := ctxt tempAt: 1. "prevOuterContext in #outer"
			ctxt return: resumptionValue ]
! !

!Character class methodsFor: '*OmniST-Core-Reflection-override' stamp: 'StefanMarr 5/7/2013 20:02'!
digitValue: x
	"We consider this as an operation on an immutable table... the unenforced here is an optimization on a global class"
	<omniUnenforced>
	
	"Answer the Character whose digit value is x. For example, answer $9 for 
	x=9, $0 for x=0, $A for x=10, $Z for x=35."

	| index |
	index := x asInteger.
	^CharacterTable at: 
		(index < 10
			ifTrue: [48 + index]
			ifFalse: [55 + index])
		+ 1! !

!Character class methodsFor: '*OmniST-Core-Reflection-override' stamp: 'StefanMarr 4/30/2013 17:23'!
value: anInteger 
	"We consider this an operation on an immutable table... the unenforced here is an optimization on a global class"
	<omniUnenforced>
	"Answer the Character whose value is anInteger."
	
	anInteger negative ifTrue:[self error: 'Characters expects a positive value.'].
	anInteger > 255 ifTrue: [^self basicNew setValue: anInteger].
	^ CharacterTable at: anInteger + 1.
! !

!Character methodsFor: '*OmniST-Core-Reflection-overrides' stamp: 'StefanMarr 5/7/2013 20:09'!
digitValue
	"We consider this as an operation on an immutable table... the unenforced here is an optimization on a global class"
	<omniUnenforced>
	
	"Answer 0-9 if the receiver is $0-$9, 10-35 if it is $A-$Z, and < 0
	otherwise. This is used to parse literal numbers of radix 2-36."

	"slow version
	| digitValue |
	(digitValue := ('0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ' indexOf: self) - 1) >= 0
		ifTrue: [ ^digitValue ].
	^ (EncodedCharSet charsetAt: self leadingChar) digitValueOf: self. "
	
	value > 16rFF ifTrue: [^(EncodedCharSet charsetAt: self leadingChar) digitValueOf: self].
	^DigitValues at: 1 + value! !

!Array methodsFor: '*OmniST-Core-Reflection-override' stamp: 'StefanMarr 12/9/2011 17:03'!
replaceFrom: start to: stop with: replacement startingAt: repStart
	"Primitive. This destructively replaces elements from start to stop in the receiver starting at index, repStart, in the collection, replacement. Answer the receiver. Range checks are performed in the primitive only. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 105>
	<omniReplacement: #omniReplaceFrom:to:with:startingAt:>
	super replaceFrom: start to: stop with: replacement startingAt: repStart! !

Array variableSubclass: #OstArray
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Core-Misc'!

!OstArray class methodsFor: 'instance creation' stamp: 'StefanMarr 1/10/2012 13:41'!
fromArray: anArray
	| array index |
	array := self new: anArray size.
	index := 0.
	anArray do: [:each | array at: (index := index + 1) put: each].
	^ array! !

!OstArray class methodsFor: 'private' stamp: 'StefanMarr 1/10/2012 13:26'!
initialize
	OstObject omnifyClass: OstArray! !

!OstArray class methodsFor: 'instance creation' stamp: 'StefanMarr 7/22/2012 00:03'!
new: size
	<omniUnenforced>
	| arr |
	arr := super new: size.
	OstDomain initializeDomainForNewObject: arr of: self.
	^ arr! !

!OstArray methodsFor: 'omni reflection' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstArray methodsFor: 'omni reflection' stamp: 'StefanMarr 1/3/2012 14:04'!
omniDomain: aDomain
	omniDomain := aDomain! !

!OstArray methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector on: self. ]
	! !

!OstArray methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector lookup: cls
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector lookup: cls on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector lookup: cls on: self. ]
	! !

!OstArray methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 of: aSelector on: self ]! !

!OstArray methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1 with: p2
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 with: p2 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 with: p2 of: aSelector on: self ]! !

!OstArray methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
		! !

!OstArray methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]! !

!OstArray methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]! !

!OstArray methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]! !

!OstArray methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]! !

!OstArray methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]! !

!OstArray methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]! !

!OstArray methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]! !

Interval subclass: #OstInterval
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Core-Misc'!

!OstInterval class methodsFor: 'private' stamp: 'StefanMarr 4/30/2013 17:32'!
initialize
	OstObject omnifyClass: self.! !

!OstInterval methodsFor: 'omni reflection' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstInterval methodsFor: 'omni reflection' stamp: 'StefanMarr 1/3/2012 14:04'!
omniDomain: aDomain
	omniDomain := aDomain! !

!OstInterval methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector on: self. ]
	! !

!OstInterval methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector lookup: cls
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector lookup: cls on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector lookup: cls on: self. ]
	! !

!OstInterval methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 of: aSelector on: self ]! !

!OstInterval methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1 with: p2
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 with: p2 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 with: p2 of: aSelector on: self ]! !

!OstInterval methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
		! !

!OstInterval methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]! !

!OstInterval methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]! !

!OstInterval methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]! !

!OstInterval methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]! !

!OstInterval methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]! !

!OstInterval methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]! !

!OstInterval methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]! !

!OstInterval methodsFor: 'private' stamp: 'StefanMarr 4/30/2013 17:33'!
species
	^ OstArray! !

!Integer methodsFor: '*OmniST-Core-Reflection-override' stamp: 'StefanMarr 7/18/2012 22:07'!
timesRepeat: aBlock
	"Evaluate the argument, aBlock, the number of times represented by the 
	receiver."

	<omniUnenforced>
	| count |
	count := 1.
	[count <= self]
		whileTrue: 
			[aBlock value.
			count := count + 1]! !

TestCase subclass: #OstTestCase
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Core-Misc'!

!OstTestCase class methodsFor: 'initialize - event' stamp: 'StefanMarr 7/21/2012 16:53'!
initialize
	OstObject omnifyClass: OstTestCase! !

!OstTestCase methodsFor: 'omni reflection' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstTestCase methodsFor: 'omni reflection' stamp: 'StefanMarr 1/3/2012 14:04'!
omniDomain: aDomain
	omniDomain := aDomain! !

!OstTestCase methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector on: self. ]
	! !

!OstTestCase methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector lookup: cls
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector lookup: cls on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector lookup: cls on: self. ]
	! !

!OstTestCase methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 of: aSelector on: self ]! !

!OstTestCase methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1 with: p2
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 with: p2 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 with: p2 of: aSelector on: self ]! !

!OstTestCase methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
		! !

!OstTestCase methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]! !

!OstTestCase methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]! !

!OstTestCase methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]! !

!OstTestCase methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]! !

!OstTestCase methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]! !

!OstTestCase methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]! !

!OstTestCase methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]! !

!Boolean methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ nil! !

!Boolean methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 7/22/2012 02:25'!
omniDomain: aDomain
	^ nil! !

!ReadStream methodsFor: '*OmniST-Core-Reflection-override' stamp: 'StefanMarr 7/29/2012 22:01'!
next
	"Primitive. Answer the next object in the Stream represented by the
	receiver. Fail if the collection of this stream is not an Array or a String.
	Fail if the stream is positioned at its end, or if the position is out of
	bounds in the collection. Optional. See Object documentation
	whatIsAPrimitive."

	<primitive: 65>
	<omniReplacement: #omniNext>
	position >= readLimit
		ifTrue: [^nil]
		ifFalse: [^collection at: (position := position + 1)]! !

!ReadStream methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 12:46'!
omniNext
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_primNext: self ]
	  ifFalse: [ ^ domain external_primNext: self ]! !

SharedQueue subclass: #OstSharedQueue
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Core-Misc'!

!OstSharedQueue class methodsFor: 'class initialization' stamp: 'StefanMarr 4/29/2013 17:03'!
initialize
	OstObject omnifyClass: self! !

!OstSharedQueue methodsFor: 'initializing' stamp: 'StefanMarr 4/29/2013 23:58'!
initialize
	monitor := OstMonitor new.
	items   := OstOrderedCollection new.! !

!OstSharedQueue methodsFor: 'omni reflection' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstSharedQueue methodsFor: 'omni reflection' stamp: 'StefanMarr 1/3/2012 14:04'!
omniDomain: aDomain
	omniDomain := aDomain! !

!OstSharedQueue methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector on: self. ]
	! !

!OstSharedQueue methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector lookup: cls
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector lookup: cls on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector lookup: cls on: self. ]
	! !

!OstSharedQueue methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 of: aSelector on: self ]! !

!OstSharedQueue methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1 with: p2
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 with: p2 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 with: p2 of: aSelector on: self ]! !

!OstSharedQueue methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
		! !

!OstSharedQueue methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]! !

!OstSharedQueue methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]! !

!OstSharedQueue methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]! !

!OstSharedQueue methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]! !

!OstSharedQueue methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]! !

!OstSharedQueue methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]! !

!OstSharedQueue methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]! !

!SharedQueue methodsFor: '*OmniST-Core-Reflection-accessing' stamp: 'StefanMarr 1/6/2012 15:37'!
peekWaiting
	^monitor critical: [
		monitor waitWhile: [ items isEmpty ].
		items first ]
! !

!ByteArray methodsFor: '*OmniST-Core-Reflection-override' stamp: 'StefanMarr 12/11/2011 18:47'!
replaceFrom: start to: stop with: replacement startingAt: repStart
	"Primitive. This destructively replaces elements from start to stop in the receiver starting at index, repStart, in the collection, replacement. Answer the receiver. Range checks are performed in the primitive only. Optional. See Object documentation whatIsAPrimitive."
	
	<primitive: 105>
	<omniReplacement: #omniReplaceFrom:to:with:startingAt:>
	super replaceFrom: start to: stop with: replacement startingAt: repStart! !

!RBCompilerDispatcher class methodsFor: '*OmniST-Core-Compiler-support' stamp: 'StefanMarr 1/13/2013 17:00'!
couldEvaluate: anObject
	"Answer true if anObject can be passed to my various #evaluate: methods."
	^anObject isString or: [ anObject isText or: [ anObject isStream ]]! !

!SequenceableCollection methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 12:49'!
omniReplaceFrom: start to: stop with: replacement startingAt: repStart
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_primReplaceFrom: start to: stop with: replacement startingAt: repStart on: self. ]
	  ifFalse: [ ^ domain external_primReplaceFrom: start to: stop with: replacement startingAt: repStart on: self. ]! !

!TraitBehavior methodsFor: '*OmniST-Core-Compiler' stamp: 'StefanMarr 12/11/2011 16:49'!
selectorsAndMethodsDo: aBlock
	"Evaluate selectorBlock for all the message selectors in my method dictionary."

	^ self methodDict keysAndValuesDo: [ :selector :method |
		selector isOmniSelector 
			ifFalse: [ aBlock value: selector value: method ] ]! !

IdentityDictionary subclass: #OstIdentityDictionary
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Core-Misc'!

!OstIdentityDictionary class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/29/2013 23:38'!
arrayType
	^ OstArray! !

!OstIdentityDictionary class methodsFor: 'class initialization' stamp: 'StefanMarr 4/29/2013 23:36'!
initialize
	OstObject omnifyClass: self.! !

!OstIdentityDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstIdentityDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/3/2012 14:04'!
omniDomain: aDomain
	omniDomain := aDomain! !

!OstIdentityDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector on: self. ]
	! !

!OstIdentityDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector lookup: cls
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector lookup: cls on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector lookup: cls on: self. ]
	! !

!OstIdentityDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 of: aSelector on: self ]! !

!OstIdentityDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1 with: p2
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 with: p2 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 with: p2 of: aSelector on: self ]! !

!OstIdentityDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
		! !

!OstIdentityDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]! !

!OstIdentityDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]! !

!OstIdentityDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]! !

!OstIdentityDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]! !

!OstIdentityDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]! !

!OstIdentityDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]! !

!OstIdentityDictionary methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]! !

!UndefinedObject methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/9/2012 17:59'!
domainForNewObjects
	^ nil! !

!UndefinedObject methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 7/18/2012 21:57'!
evaluateInContext: aBlock
	<omniUnenforced>
	^ OstDomain new evaluateInContext: aBlock! !

!UndefinedObject methodsFor: '*OmniST-Core-primitive handlers' stamp: 'StefanMarr 1/29/2013 13:21'!
external_primAt: idx on: anObj
	<omniUnenforced>
	^ anObj at: idx! !

!UndefinedObject methodsFor: '*OmniST-Core-primitive handlers' stamp: 'StefanMarr 1/29/2013 13:21'!
external_primAt: idx on: anObj put: aVal
	<omniUnenforced>
	^ anObj at: idx put: aVal! !

!UndefinedObject methodsFor: '*OmniST-Core-primitive handlers' stamp: 'StefanMarr 1/29/2013 13:21'!
external_primBasicAt: idx on: anObj
	<omniUnenforced>
	^ anObj basicAt: idx! !

!UndefinedObject methodsFor: '*OmniST-Core-primitive handlers' stamp: 'StefanMarr 1/29/2013 13:22'!
external_primBasicAt: idx on: anObj put: aVal
	<omniUnenforced>
	^ anObj basicAt: idx put: aVal! !

!UndefinedObject methodsFor: '*OmniST-Core-primitive handlers' stamp: 'StefanMarr 1/29/2013 13:22'!
external_primInstVarAt: idx on: anObj
	<omniUnenforced>
	^ anObj instVarAt: idx! !

!UndefinedObject methodsFor: '*OmniST-Core-primitive handlers' stamp: 'StefanMarr 1/29/2013 13:22'!
external_primInstVarAt: idx on: anObj put: aVal
	<omniUnenforced>
	^ anObj instVarAt: idx put: aVal! !

!UndefinedObject methodsFor: '*OmniST-Core-primitive handlers' stamp: 'StefanMarr 1/29/2013 13:22'!
external_primNext: obj
	<omniUnenforced>
	^ obj next! !

!UndefinedObject methodsFor: '*OmniST-Core-primitive handlers' stamp: 'StefanMarr 1/29/2013 13:22'!
external_primNext: obj put: val
	<omniUnenforced>
	^ obj nextPut: val! !

!UndefinedObject methodsFor: '*OmniST-Core-primitive handlers' stamp: 'StefanMarr 1/29/2013 13:22'!
external_primReplaceFrom: start to: stop with: replacement startingAt: repStart on: obj
	<omniUnenforced>
	^ obj replaceFrom: start to: stop with: replacement startingAt: repStart! !

!UndefinedObject methodsFor: '*OmniST-Core-primitive handlers' stamp: 'StefanMarr 1/29/2013 13:22'!
external_primShallowCopy: anObj
	<omniUnenforced>
	^ anObj shallowCopy! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers external' stamp: 'StefanMarr 1/29/2013 18:33'!
external_readField: idx of: obj
	<omniUnenforced>
	^ obj instVarAt: idx! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers external' stamp: 'StefanMarr 1/29/2013 18:33'!
external_readLiteral: association
	<omniUnenforced>
	^ association value! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers external' stamp: 'StefanMarr 1/29/2013 20:10'!
external_requestExecution: p1 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers external' stamp: 'StefanMarr 1/29/2013 20:10'!
external_requestExecution: p1 with: p2 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers external' stamp: 'StefanMarr 1/29/2013 20:10'!
external_requestExecution: p1 with: p2 with: p3 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers external' stamp: 'StefanMarr 1/29/2013 20:10'!
external_requestExecution: p1 with: p2 with: p3 with: p4 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers external' stamp: 'StefanMarr 1/29/2013 20:10'!
external_requestExecution: p1 with: p2 with: p3 with: p4 with: p5 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers external' stamp: 'StefanMarr 1/29/2013 20:09'!
external_requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers external' stamp: 'StefanMarr 1/29/2013 20:09'!
external_requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers external' stamp: 'StefanMarr 1/29/2013 20:09'!
external_requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers external' stamp: 'StefanMarr 1/29/2013 20:09'!
external_requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers external' stamp: 'StefanMarr 1/29/2013 20:09'!
external_requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers external' stamp: 'StefanMarr 1/29/2013 20:07'!
external_requestExecutionOf: aSelector lookup: cls on: anObject
	<omniUnenforced>
	^ anObject performSuper: aSelector inLookupClass: cls! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers external' stamp: 'StefanMarr 1/29/2013 20:06'!
external_requestExecutionOf: aSelector lookup: cls on: anObject with: p1
	<omniUnenforced>
	^ anObject performSuper: aSelector with: { p1 } inLookupClass: cls.! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers external' stamp: 'StefanMarr 1/29/2013 20:06'!
external_requestExecutionOf: aSelector lookup: cls on: anObject with: p1 with: p2
	<omniUnenforced>
	^ anObject performSuper: aSelector with: { p1. p2 } inLookupClass: cls.! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers external' stamp: 'StefanMarr 1/29/2013 20:06'!
external_requestExecutionOf: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers external' stamp: 'StefanMarr 1/29/2013 18:35'!
external_write: val toField: idx of: obj
	<omniUnenforced>
	obj instVarAt: idx put: val.
	^ val! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers external' stamp: 'StefanMarr 1/29/2013 18:36'!
external_write: val toField: idx of: obj return: returnValue
	<omniUnenforced>
	obj instVarAt: idx put: val.
	^ returnValue! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers external' stamp: 'StefanMarr 1/29/2013 18:36'!
external_write: val toLiteral: association
	<omniUnenforced>
	^ association value: val! !

!UndefinedObject methodsFor: '*OmniST-Core-primitive handlers' stamp: 'StefanMarr 1/29/2013 13:20'!
internal_primAt: idx on: anObj
	<omniUnenforced>
	^ anObj at: idx! !

!UndefinedObject methodsFor: '*OmniST-Core-primitive handlers' stamp: 'StefanMarr 1/29/2013 13:20'!
internal_primAt: idx on: anObj put: aVal
	<omniUnenforced>
	^ anObj at: idx put: aVal! !

!UndefinedObject methodsFor: '*OmniST-Core-primitive handlers' stamp: 'StefanMarr 1/29/2013 13:20'!
internal_primBasicAt: idx on: anObj
	<omniUnenforced>
	^ anObj basicAt: idx! !

!UndefinedObject methodsFor: '*OmniST-Core-primitive handlers' stamp: 'StefanMarr 1/29/2013 13:20'!
internal_primBasicAt: idx on: anObj put: aVal
	<omniUnenforced>
	^ anObj basicAt: idx put: aVal! !

!UndefinedObject methodsFor: '*OmniST-Core-primitive handlers' stamp: 'StefanMarr 1/29/2013 13:20'!
internal_primInstVarAt: idx on: anObj
	<omniUnenforced>
	^ anObj instVarAt: idx! !

!UndefinedObject methodsFor: '*OmniST-Core-primitive handlers' stamp: 'StefanMarr 1/29/2013 13:21'!
internal_primInstVarAt: idx on: anObj put: aVal
	<omniUnenforced>
	^ anObj instVarAt: idx put: aVal! !

!UndefinedObject methodsFor: '*OmniST-Core-primitive handlers' stamp: 'StefanMarr 1/29/2013 13:21'!
internal_primNext: obj
	<omniUnenforced>
	^ obj next! !

!UndefinedObject methodsFor: '*OmniST-Core-primitive handlers' stamp: 'StefanMarr 1/29/2013 13:21'!
internal_primNext: obj put: val
	<omniUnenforced>
	^ obj nextPut: val! !

!UndefinedObject methodsFor: '*OmniST-Core-primitive handlers' stamp: 'StefanMarr 1/29/2013 13:20'!
internal_primReplaceFrom: start to: stop with: replacement startingAt: repStart on: obj
	<omniUnenforced>
	^ obj replaceFrom: start to: stop with: replacement startingAt: repStart! !

!UndefinedObject methodsFor: '*OmniST-Core-primitive handlers' stamp: 'StefanMarr 1/29/2013 13:20'!
internal_primShallowCopy: anObj
	<omniUnenforced>
	^ anObj shallowCopy! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers internal' stamp: 'StefanMarr 1/29/2013 18:34'!
internal_readField: idx of: obj
	<omniUnenforced>
	^ obj instVarAt: idx! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers internal' stamp: 'StefanMarr 1/29/2013 18:34'!
internal_readLiteral: association
	<omniUnenforced>
	^ association value! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers internal' stamp: 'StefanMarr 1/29/2013 20:11'!
internal_requestExecution: p1 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers internal' stamp: 'StefanMarr 1/29/2013 20:12'!
internal_requestExecution: p1 with: p2 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers internal' stamp: 'StefanMarr 1/29/2013 20:12'!
internal_requestExecution: p1 with: p2 with: p3 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers internal' stamp: 'StefanMarr 1/29/2013 20:12'!
internal_requestExecution: p1 with: p2 with: p3 with: p4 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers internal' stamp: 'StefanMarr 1/29/2013 20:12'!
internal_requestExecution: p1 with: p2 with: p3 with: p4 with: p5 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers internal' stamp: 'StefanMarr 1/29/2013 20:12'!
internal_requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers internal' stamp: 'StefanMarr 1/29/2013 20:12'!
internal_requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers internal' stamp: 'StefanMarr 1/29/2013 20:12'!
internal_requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers internal' stamp: 'StefanMarr 1/29/2013 20:12'!
internal_requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers internal' stamp: 'StefanMarr 1/29/2013 20:13'!
internal_requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers internal' stamp: 'StefanMarr 1/29/2013 20:13'!
internal_requestExecutionOf: aSelector lookup: cls on: anObject
	<omniUnenforced>
	^ anObject performSuper: aSelector inLookupClass: cls! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers internal' stamp: 'StefanMarr 1/29/2013 20:13'!
internal_requestExecutionOf: aSelector lookup: cls on: anObject with: p1
	<omniUnenforced>
	^ anObject performSuper: aSelector with: { p1 } inLookupClass: cls.! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers internal' stamp: 'StefanMarr 1/29/2013 20:13'!
internal_requestExecutionOf: aSelector lookup: cls on: anObject with: p1 with: p2
	<omniUnenforced>
	^ anObject performSuper: aSelector with: { p1. p2 } inLookupClass: cls.! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers internal' stamp: 'StefanMarr 1/29/2013 20:13'!
internal_requestExecutionOf: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers internal' stamp: 'StefanMarr 1/29/2013 18:35'!
internal_write: val toField: idx of: obj
	<omniUnenforced>
	obj instVarAt: idx put: val.
	^ val! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers internal' stamp: 'StefanMarr 1/29/2013 18:35'!
internal_write: val toField: idx of: obj return: returnValue
	<omniUnenforced>
	obj instVarAt: idx put: val.
	^ returnValue! !

!UndefinedObject methodsFor: '*OmniST-Core-handlers internal' stamp: 'StefanMarr 1/29/2013 18:35'!
internal_write: val toLiteral: association
	<omniUnenforced>
	^ association value: val! !

!UndefinedObject methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ nil! !

!UndefinedObject methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 7/22/2012 02:25'!
omniDomain: aDomain
	^ nil! !

Object subclass: #OPromise
	instanceVariableNames: 'signal value terminatedWithError'
	classVariableNames: 'NoValueDelivered'
	poolDictionaries: ''
	category: 'OmniST-Core-Misc'!

!OPromise class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/6/2011 00:19'!
example
	"This is not a real test case, but just to see how it is supposed to work"
	| p |
	p := OPromise new.
	
	[|val| 
	 Transcript log: 'About to read promised value.'.
	 val := p read.
	 Transcript log: 'Val: ', val asString.] fork.

	Processor yield.
	
	Transcript log: 'About to deliver promised value.'.
	p deliver: 42.
	Transcript log: 'Deliver promised value.'.
	! !

!OPromise class methodsFor: 'initialization' stamp: 'StefanMarr 11/4/2011 15:53'!
initialize
	NoValueDelivered := Object new.! !

!OPromise methodsFor: 'promise' stamp: 'StefanMarr 5/13/2013 17:59'!
await
	<omniUnenforced>
	| i |
	i := 0.
	[value = NoValueDelivered and: [terminatedWithError = nil]] whileTrue: [
		"This is ugly, but I do not see how I can prevent the data
		 race for signals otherwise.
		 In case there are multiple possible consumers everyone
		 but the first will starve when they arrive before the
		 promise was delivered.
		 Now, we just have a delay, but it is guaranteed to return."
		signal waitTimeoutMSecs: 100.
		i := i + 1.
		i > 300 ifTrue: [Halt now.].
	].! !

!OPromise methodsFor: 'promise' stamp: 'StefanMarr 7/18/2012 21:57'!
deliver: aValue
	<omniUnenforced>
	"Deliver the promised value."
	
	
	"Warning: this is racy, but we don't care for the moment.
	 Should be a single produce anyway. Everything else is a bug.
	 And, we do at least best effort error notification..."
	value = NoValueDelivered ifFalse: [
		| err |
		err := Error new.
		err messageText: 'Promise has been delivered more than once.'.
		err signal.
	].

	value := aValue.
	
	signal signal.
	
	^ value.! !

!OPromise methodsFor: 'promise' stamp: 'StefanMarr 1/23/2013 13:32'!
failed: anError
	terminatedWithError := anError! !

!OPromise methodsFor: 'initialization' stamp: 'StefanMarr 11/4/2011 16:09'!
initialize
	value := NoValueDelivered.
	signal := Semaphore new.! !

!OPromise methodsFor: 'accessing' stamp: 'StefanMarr 1/23/2013 13:33'!
read
	<omniUnenforced>
	self await.
	terminatedWithError = nil ifTrue: [
		^ value ].
	
	"On failure, raise the exception again in the current context."
	terminatedWithError signal! !

!Object methodsFor: '*OmniST-Core-Reflection-overrides' stamp: 'StefanMarr 1/3/2012 15:44'!
at: index 
	"Primitive. Assumes receiver is indexable. Answer the value of an 
	indexable element in the receiver. Fail if the argument index is not an 
	Integer or is out of bounds. Essential. See Object documentation 
	whatIsAPrimitive."

	<primitive: 60>
	<omniReplacement: #omniAt:>
	index isInteger ifTrue:
		[self class isVariable
			ifTrue: [self errorSubscriptBounds: index]
			ifFalse: [self errorNotIndexable]].
	index isNumber
		ifTrue: [^self at: index asInteger]
		ifFalse: [self errorNonIntegerIndex]! !

!Object methodsFor: '*OmniST-Core-Reflection-overrides' stamp: 'StefanMarr 1/3/2012 15:49'!
at: index put: value
	"Primitive. Assumes receiver is indexable. Store the argument value in 
	the indexable element of the receiver indicated by index. Fail if the 
	index is not an Integer or is out of bounds. Or fail if the value is not of 
	the right type for this kind of collection. Answer the value that was 
	stored. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 61>
	<omniReplacement: #omniAt:put:>
	index isInteger ifTrue:
		[self class isVariable
			ifTrue: [(index >= 1 and: [index <= self size])
					ifTrue: [self errorImproperStore]
					ifFalse: [self errorSubscriptBounds: index]]
			ifFalse: [self errorNotIndexable]].
	index isNumber
		ifTrue: [^self at: index asInteger put: value]
		ifFalse: [self errorNonIntegerIndex]! !

!Object methodsFor: '*OmniST-Core-VM-Compat' stamp: 'StefanMarr 5/1/2012 21:57'!
baselevelPerform: aSymbol 
	<primitive: 83>
	^ self perform: aSymbol withArguments: (Array new: 0)! !

!Object methodsFor: '*OmniST-Core-VM-Compat' stamp: 'StefanMarr 5/1/2012 20:51'!
baselevelPerform: aSymbol with: anObject 
	<primitive: 83>
	^ self perform: aSymbol withArguments: (Array with: anObject)! !

!Object methodsFor: '*OmniST-Core-VM-Compat' stamp: 'StefanMarr 5/1/2012 20:52'!
baselevelPerform: aSymbol with: firstObject with: secondObject 
	<primitive: 83>
	^ self perform: aSymbol withArguments: (Array with: firstObject with: secondObject)! !

!Object methodsFor: '*OmniST-Core-VM-Compat' stamp: 'StefanMarr 5/1/2012 20:52'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject 
	<primitive: 83>
	^ self perform: aSymbol
		withArguments: (Array with: firstObject with: secondObject with: thirdObject)! !

!Object methodsFor: '*OmniST-Core-VM-Compat' stamp: 'StefanMarr 5/1/2012 22:00'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: o4
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: (Array with: firstObject with: secondObject with: thirdObject with: o4)! !

!Object methodsFor: '*OmniST-Core-VM-Compat' stamp: 'StefanMarr 5/1/2012 22:01'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: o4 with: o5
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: (Array with: firstObject with: secondObject with: thirdObject with: o4 with: o5)! !

!Object methodsFor: '*OmniST-Core-VM-Compat' stamp: 'StefanMarr 5/1/2012 22:01'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: (Array with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6)! !

!Object methodsFor: '*OmniST-Core-VM-Compat' stamp: 'StefanMarr 5/1/2012 22:01'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6 with: o7
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: (Array with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6 with: o7)! !

!Object methodsFor: '*OmniST-Core-VM-Compat' stamp: 'StefanMarr 5/1/2012 22:02'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6 with: o7 with: o8
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. o4. o5. o6. o7. o8}! !

!Object methodsFor: '*OmniST-Core-VM-Compat' stamp: 'StefanMarr 5/1/2012 22:02'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6 with: o7 with: o8 with: o9
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. o4. o5. o6. o7. o8. o9}! !

!Object methodsFor: '*OmniST-Core-VM-Compat' stamp: 'StefanMarr 5/1/2012 22:02'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6 with: o7 with: o8 with: o9 with: o10
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. o4. o5. o6. o7. o8. o9. o10}! !

!Object methodsFor: '*OmniST-Core-VM-Compat' stamp: 'StefanMarr 5/1/2012 20:49'!
baselevelPerform: selector withArguments: argArray 
	<primitive: 84>
	^ self perform: selector withArguments: argArray inSuperclass: self class! !

!Object methodsFor: '*OmniST-Core-VM-Compat' stamp: 'StefanMarr 5/1/2012 22:00'!
baselevelPerform: selector withArguments: argArray inSuperclass: lookupClass
	"NOTE:  This is just like perform:withArguments:, except that
	the message lookup process begins, not with the receivers's class,
	but with the supplied superclass instead.  It will fail if lookupClass
	cannot be found among the receiver's superclasses.
	Primitive. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 100>
	(selector isSymbol)
		ifFalse: [^ self error: 'selector argument must be a Symbol'].
	(selector numArgs = argArray size)
		ifFalse: [^ self error: 'incorrect number of arguments'].
	(self class == lookupClass or: [self class inheritsFrom: lookupClass])
		ifFalse: [^ self error: 'lookupClass is not in my inheritance chain'].
	self primitiveFailed! !

!Object methodsFor: '*OmniST-Core-Reflection-overrides' stamp: 'StefanMarr 1/3/2012 15:51'!
basicAt: index
	"Primitive. Assumes receiver is indexable. Answer the value of an 
	indexable element in the receiver. Fail if the argument index is not an 
	Integer or is out of bounds. Essential. Do not override in a subclass. See 
	Object documentation whatIsAPrimitive."

	<primitive: 60>
	<omniReplacement: #omniBasicAt:>
	index isInteger ifTrue: [self errorSubscriptBounds: index].
	index isNumber
		ifTrue: [^self basicAt: index asInteger]
		ifFalse: [self errorNonIntegerIndex]! !

!Object methodsFor: '*OmniST-Core-Reflection-overrides' stamp: 'StefanMarr 1/3/2012 15:51'!
basicAt: index put: value
	"Primitive. Assumes receiver is indexable. Store the second argument 
	value in the indexable element of the receiver indicated by index. Fail 
	if the index is not an Integer or is out of bounds. Or fail if the value is 
	not of the right type for this kind of collection. Answer the value that 
	was stored. Essential. Do not override in a subclass. See Object 
	documentation whatIsAPrimitive."

	<primitive: 61>
	<omniReplacement: #omniBasicAt:put:>
	index isInteger
		ifTrue: [(index >= 1 and: [index <= self size])
					ifTrue: [self errorImproperStore]
					ifFalse: [self errorSubscriptBounds: index]].
	index isNumber
		ifTrue: [^self basicAt: index asInteger put: value]
		ifFalse: [self errorNonIntegerIndex]! !

!Object methodsFor: '*OmniST-Core-Reflection-overrides' stamp: 'StefanMarr 7/18/2012 21:57'!
doesNotUnderstand: aMessage 
	 "Handle the fact that there was an attempt to send the given message to the receiver but the receiver does not understand this message (typically sent from the machine when a message is sent to the receiver and no method is defined for that selector)."
	"Testing: (3 activeProcess)"
	"fixed suggested by Eliot miranda to make sure 
	
	[Object new blah + 1]
		on: MessageNotUnderstood
		do: [:e | e resume: 1] does not loop indefinitively"
		
	| exception resumeValue |
	
	<omniUnenforced>	
	aMessage selector isOmniSelector
		ifTrue: [
			OstCompiler omniMethod: aMessage missing: self in: aMessage lookupClass.
			
			((self respondsTo: aMessage selector) or: [
			  self isBehavior and: [self canUnderstand: aMessage selector]])
			ifTrue: [
				"And try again."
				^ aMessage sentTo: self.
			]].
		
	(exception := MessageNotUnderstood new)
				message: aMessage;
				receiver: self.
	resumeValue := exception signal.
	^exception reachedDefaultHandler
				ifTrue: [aMessage sentTo: self]
				ifFalse: [resumeValue]! !

!Object methodsFor: '*OmniST-Core-Reflection-overrides' stamp: 'StefanMarr 7/18/2012 21:57'!
halt
	"This is the typical message to use for inserting breakpoints during 
	debugging. It behaves like halt:, but does not call on halt: in order to 
	avoid putting this message on the stack. Halt is especially useful when 
	the breakpoint message is an arbitrary one."

	<omniUnenforced>
	Halt signal! !

!Object methodsFor: '*OmniST-Core-Reflection-overrides' stamp: 'StefanMarr 1/3/2012 15:59'!
instVarAt: index 
	"Primitive. Answer a fixed variable in an object. The numbering of the 
	variables corresponds to the named instance variables. Fail if the index 
	is not an Integer or is not the index of a fixed variable. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 73>
	<omniReplacement: #omniInstVarAt:>
	"Access beyond fixed variables."
	^self basicAt: index - self class instSize		! !

!Object methodsFor: '*OmniST-Core-Reflection-overrides' stamp: 'StefanMarr 1/3/2012 16:01'!
instVarAt: anInteger put: anObject 
	"Primitive. Store a value into a fixed variable in the receiver. The 
	numbering of the variables corresponds to the named instance variables. 
	Fail if the index is not an Integer or is not the index of a fixed variable. 
	Answer the value stored as the result. Using this message violates the 
	principle that each object has sovereign control over the storing of 
	values into its instance variables. Essential. See Object documentation 
	whatIsAPrimitive."

	<primitive: 74>
	<omniReplacement: #omniInstVarAt:put:>
	"Access beyond fixed fields"
	^self basicAt: anInteger - self class instSize put: anObject! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 12:39'!
omniAt: idx
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_primAt: idx on: self. ]
	  ifFalse: [ ^ domain external_primAt: idx on: self. ]! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 12:40'!
omniAt: idx put: anObject
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_primAt: idx on: self put: anObject. ]
	  ifFalse: [ ^ domain external_primAt: idx on: self put: anObject. ]! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 12:40'!
omniBasicAt: idx
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_primBasicAt: idx on: self. ]
	  ifFalse: [ ^ domain external_primBasicAt: idx on: self. ]! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 12:40'!
omniBasicAt: idx put: anObject
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_primBasicAt: idx on: self put: anObject. ]
	  ifFalse: [ ^ domain external_primBasicAt: idx on: self put: anObject. ]! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ OstDomain ownerFor: self! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 7/22/2012 00:35'!
omniDomain: aDomain
	^ OstDomain ownerFor: self put: aDomain! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 12:40'!
omniInstVarAt: anInteger
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_primInstVarAt: anInteger on: self. ]
	  ifFalse: [ ^ domain external_primInstVarAt: anInteger on: self. ]! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 12:40'!
omniInstVarAt: anInteger put: aVal
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_primInstVarAt: anInteger on: self put: aVal. ]
	  ifFalse: [ ^ domain external_primInstVarAt: anInteger on: self put: aVal. ]! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 12:40'!
omniShallowCopy
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_primShallowCopy: self. ]
	  ifFalse: [ ^ domain external_primShallowCopy: self. ]! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 12/9/2011 15:59'!
perform: aSymbol with: firstObject with: secondObject with: thirdObject with: o4
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: (Array with: firstObject with: secondObject with: thirdObject with: o4)! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 12/12/2011 16:40'!
perform: aSymbol with: firstObject with: secondObject with: thirdObject with: o4 with: o5
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: (Array with: firstObject with: secondObject with: thirdObject with: o4 with: o5)! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 12/12/2011 16:40'!
perform: aSymbol with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: (Array with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6)! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 12/12/2011 16:40'!
perform: aSymbol with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6 with: o7
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: (Array with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6 with: o7)! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/8/2012 14:51'!
perform: aSymbol with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6 with: o7 with: o8
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. o4. o5. o6. o7. o8}! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/8/2012 14:51'!
perform: aSymbol with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6 with: o7 with: o8 with: o9
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. o4. o5. o6. o7. o8. o9}! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/8/2012 14:51'!
perform: aSymbol with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6 with: o7 with: o8 with: o9 with: o10
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. o4. o5. o6. o7. o8. o9. o10}! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 12/12/2011 09:38'!
performSuper: aSymbol inLookupClass: cls
	<primitive: 100>
	^ self perform: aSymbol withArguments: (Array new: 0) inSuperclass: cls! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/5/2012 16:08'!
performSuper: aSymbol with: args inLookupClass: cls
	"Send the selector, aSymbol, to the receiver with anObject as its argument.
	Fail if the number of arguments expected by the selector is not one.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 100>
	^ self perform: aSymbol withArguments: args inSuperclass: cls! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 14:19'!
requestExecutionOf: aSelector
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_requestExecutionOf: aSelector on: self. ]
	  ifFalse: [ ^ domain external_requestExecutionOf: aSelector on: self. ]
	! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 14:23'!
requestExecutionOf: aSelector lookup: cls
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_requestExecutionOf: aSelector lookup: cls on: self. ]
	  ifFalse: [ ^ domain external_requestExecutionOf: aSelector lookup: cls on: self. ]
	! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 14:24'!
requestExecutionOf: aSelector lookup: cls with: p1
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_requestExecutionOf: aSelector lookup: cls on: self with: p1. ]
	  ifFalse: [ ^ domain external_requestExecutionOf: aSelector lookup: cls on: self with: p1. ]! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 14:24'!
requestExecutionOf: aSelector lookup: cls with: p1 with: p2
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_requestExecutionOf: aSelector lookup: cls on: self with: p1 with: p2. ]
	  ifFalse: [ ^ domain external_requestExecutionOf: aSelector lookup: cls on: self with: p1 with: p2. ]! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 14:24'!
requestExecutionOf: aSelector lookup: cls with: p1 with: p2 with: p3
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_requestExecutionOf: aSelector lookup: cls on: self with: p1 with: p2 with: p3. ]
	  ifFalse: [ ^ domain external_requestExecutionOf: aSelector lookup: cls on: self with: p1 with: p2 with: p3. ]! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 14:24'!
requestExecutionOf: aSelector lookup: cls with: p1 with: p2 with: p3 with: p4
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_requestExecutionOf: aSelector lookup: cls on: self with: p1 with: p2 with: p3 with: p4 ]
	  ifFalse: [ ^ domain external_requestExecutionOf: aSelector lookup: cls on: self with: p1 with: p2 with: p3 with: p4 ]! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 14:25'!
requestExecutionOf: aSelector with: p1
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_requestExecution: p1 of: aSelector on: self ]
	  ifFalse: [ ^ domain external_requestExecution: p1 of: aSelector on: self ]! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 14:25'!
requestExecutionOf: aSelector with: p1 with: p2
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_requestExecution: p1 with: p2 of: aSelector on: self ]
	  ifFalse: [ ^ domain external_requestExecution: p1 with: p2 of: aSelector on: self ]! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 14:25'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
	  ifFalse: [ ^ domain external_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 14:26'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]
	  ifFalse: [ ^ domain external_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 14:26'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]
	  ifFalse: [ ^ domain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 14:26'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]
	  ifFalse: [ ^ domain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 14:26'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]
	  ifFalse: [ ^ domain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 14:27'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]
	  ifFalse: [ ^ domain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 14:27'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]
	  ifFalse: [ ^ domain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]! !

!Object methodsFor: '*OmniST-Core-Reflection' stamp: 'StefanMarr 1/30/2013 14:27'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
	<omniUnenforced>
	| domain |
	domain := self omniDomain.
	Processor activeProcess omniDomain == domain
	  ifTrue:  [ ^ domain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]
	  ifFalse: [ ^ domain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]! !

!Object methodsFor: '*OmniST-Core-Reflection-overrides' stamp: 'StefanMarr 1/10/2012 11:42'!
shallowCopy
	"Answer a copy of the receiver which shares the receiver's instance variables. It should never be overridden. I'm invoked from the copy template method. Subclasses that need to specialize the copy should specialize the postCopy hook method."
	
	| class newObject index |
	<omniReplacement: #omniShallowCopy>
	<primitive: 148>
	class := self class.
	class isVariable
		ifTrue: 
			[index := self basicSize.
			newObject := class basicNew: index.
			[index > 0]
				whileTrue: 
					[newObject basicAt: index put: (self basicAt: index).
					index := index - 1]]
		ifFalse: [newObject := class basicNew].
	index := class instSize.
	[index > 0]
		whileTrue: 
			[newObject instVarAt: index put: (self instVarAt: index).
			index := index - 1].
	^ newObject! !

!Object methodsFor: '*OmniST-Core-Reflection-overrides' stamp: 'StefanMarr 7/18/2012 22:08'!
subclassResponsibility
	"This message sets up a framework for the behavior of the class' subclasses.
	Announce that the subclass should have implemented this message."
	<omniUnenforced>
	SubclassResponsibility signalFor: thisContext sender selector! !

Object subclass: #OstMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Core-Reflection'!

!OstMirror class methodsFor: 'primitives' stamp: 'StefanMarr 3/20/2012 15:48'!
domainOf: obj
	^ obj omniDomain! !

!OstMirror class methodsFor: 'primitives' stamp: 'StefanMarr 1/30/2013 13:20'!
executesOnBaseLevel
	<omniUnenforced>
	thisContext sender ifNotNilDo: [:senderCtx |
		((senderCtx selector beginsWith: #internal_request) or: [
		 (senderCtx selector beginsWith: #external_request)]) ifTrue: [
			| args |
			args := senderCtx arguments.
			^ (args at: (args size - 1)) isOmniSelector.
		]
	].
	
	^ false.! !

!OstMirror class methodsFor: 'primitives' stamp: 'StefanMarr 3/20/2012 15:49'!
setDomainOf: obj to: domain
	obj omniDomain: domain! !

Object subclass: #OstObject
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Core-Misc'!

OstObject subclass: #OstDomain
	instanceVariableNames: ''
	classVariableNames: 'RegReads RegWrites Registry SomeContext'
	poolDictionaries: ''
	category: 'OmniST-Core-Reflection'!

!OstDomain class methodsFor: 'omni reflection' stamp: 'StefanMarr 8/29/2012 18:20'!
currentDomain
	<omniUnenforced>
	^ Processor thisProcess omniDomain! !

!OstDomain class methodsFor: 'omni reflection' stamp: 'StefanMarr 12/7/2011 23:08'!
domainIndexFromClass: cls
	^ cls instVarIndexFor: #omniDomain! !

!OstDomain class methodsFor: 'omni reflection' stamp: 'StefanMarr 12/11/2011 18:32'!
domainIndexFromObject: obj
	^ self domainIndexFromClass: obj class! !

!OstDomain class methodsFor: 'class initialization' stamp: 'StefanMarr 4/27/2013 18:25'!
initialize
	" OstDomain initialize "
	(Process hasInstVarNamed: #omniDomain) ifFalse: [
		Process addInstVarNamed: #omniDomain.
	].

	Registry := WeakIdentityKeyDictionary new.
	RegReads := IdentityDictionary new.
	RegWrites := IdentityDictionary new.! !

!OstDomain class methodsFor: 'class initialization' stamp: 'StefanMarr 1/30/2013 15:05'!
initializeAllOmnifiedClasses
	" self initializeAllOmnifiedClasses "
	| omnifiedClasses |
	omnifiedClasses := Metaclass allInstances select: [:c |
		(c methodDict at: #initialize ifPresent: [:init | 
			init sendsSelector: #omnifyClass:]) = true ].
	
	omnifiedClasses do: [:c | c theNonMetaClass initialize ].
	
	^ omnifiedClasses! !

!OstDomain class methodsFor: 'omni instantiation' stamp: 'StefanMarr 3/9/2012 21:56'!
initializeDomainForNewObject: obj of: class
	"We rely here currently on the getters/setters being available.
	 This is not exactly in sync with what the 'Mirrorified' reflection API for Omni actually should provide.
	 but I hope this does not have to many performance implications. :("
	obj omniDomain: self currentDomain domainForNewObjects.
! !

!OstDomain class methodsFor: 'class initialization' stamp: 'StefanMarr 7/21/2012 18:21'!
makeNilADomain
	"self makeNilADomain"
	"Then copy the methods"
	((self organization listAtCategoryNamed: 'omni handlers')
	 union: (self organization listAtCategoryNamed: 'omni primitive handlers'))
	 do: [:selector |
		| method |
		method := self lookupSelector: selector.
		UndefinedObject
				compile: method getSourceFromFile
		       classified: #'*OmniST-Core-Reflection'
		       withStamp: method timeStamp
		       notifying: nil
		       logSource: true.
	].! !

!OstDomain class methodsFor: 'omni reflection' stamp: 'StefanMarr 12/11/2011 18:37'!
omniDomainFrom: obj
	| idx |
	idx := self domainIndexFromObject: obj.
	
	idx ~= 0 ifTrue: [
		^ obj instVarAt: idx.
	].

	^ nil! !

!OstDomain class methodsFor: 'omni compatibility' stamp: 'StefanMarr 5/13/2013 18:49'!
ownerFor: obj
	<omniUnenforced>
	| reads |
	reads := RegReads at: obj class ifAbsent: 0.
	RegReads at: obj class put: reads + 1.
	
	obj class == Array ifTrue: [
		"Halt now."
		SomeContext := {
		thisContext sender.
		thisContext sender sender.
		thisContext sender sender sender.
		thisContext sender sender sender sender.
		thisContext sender sender sender sender sender.
		thisContext sender sender sender sender sender sender.
		thisContext sender sender sender sender sender sender sender.
		thisContext sender sender sender sender sender sender sender sender.
		thisContext sender sender sender sender sender sender sender sender sender.
		thisContext sender sender sender sender sender sender sender sender sender sender.
		thisContext sender sender sender sender sender sender sender sender sender sender sender.
		}].
	
	^ Registry at: obj ifAbsent: [nil]! !

!OstDomain class methodsFor: 'omni compatibility' stamp: 'StefanMarr 4/27/2013 18:54'!
ownerFor: obj put: domain
	| writes |
	writes := RegWrites at: obj class ifAbsent: 0.
	RegWrites at: obj class put: writes + 1.
	
	^ Registry at: obj put: domain! !

!OstDomain class methodsFor: 'omni reflection' stamp: 'StefanMarr 7/22/2012 00:40'!
setOmniDomainOn: obj of: cls to: aDomain
	| idx |
	"idx := self domainIndexFromClass: cls.
	idx > 0
		ifTrue:  [obj instVarAt: idx put: aDomain.]
		ifFalse: [obj omniDomain: aDomain]"
	obj omniDomain: aDomain.! !

!OstDomain class methodsFor: 'initialize-release' stamp: 'StefanMarr 1/9/2012 22:53'!
unload
	(self == OstDomain and: [Process hasInstVarNamed: #omniDomain]) ifTrue: [
		Process removeInstVarNamed: #omniDomain.
	].! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 7/22/2012 01:58'!
adoptObject: obj
	<omniUnenforced>
	"self class setOmniDomainOn: obj of: obj class to: self."
	obj omniDomain: self.
	^ obj! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 12/8/2011 14:06'!
domainForNewObjects
	"#basicNew need to determine which domain a new object is supposed
	 to belong to.
	 The standard domain is self, the domain of the currently executing
	 OProcess.
	
	 If this method is overriden, make sure that you do not allocate any objects here!!!!!!"
	^ self! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 7/22/2012 01:58'!
evaluateInContext: aBlock
	<omniUnenforced>
	| oldDomain proc result |
	proc := Processor activeProcess.
	
	oldDomain := proc omniDomain.
	
	proc omniDomain: self.
	
	result := aBlock value.
	
	proc omniDomain: oldDomain.
	
	^ result! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 8/2/2012 14:50'!
evaluateInContextOnBaseLevel: aBlock
	<omniUnenforced>
	"We require in this Omni implementation
	 that the block is properly transformed
	 for an execution on the baselevel."
	^ self evaluateInContext: aBlock.! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/29/2013 13:07'!
external_primAt: idx on: anObj
	<omniUnenforced>
	^ anObj at: idx! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/29/2013 13:08'!
external_primAt: idx on: anObj put: aVal
	<omniUnenforced>
	^ anObj at: idx put: aVal! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/29/2013 13:08'!
external_primBasicAt: idx on: anObj
	<omniUnenforced>
	^ anObj basicAt: idx! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/29/2013 13:14'!
external_primBasicAt: idx on: anObj put: aVal
	<omniUnenforced>
	^ anObj basicAt: idx put: aVal! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/29/2013 13:14'!
external_primInstVarAt: idx on: anObj
	<omniUnenforced>
	^ anObj instVarAt: idx! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/29/2013 13:14'!
external_primInstVarAt: idx on: anObj put: aVal
	<omniUnenforced>
	^ anObj instVarAt: idx put: aVal! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/29/2013 13:13'!
external_primNext: obj
	<omniUnenforced>
	^ obj next! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/29/2013 13:08'!
external_primNext: obj put: val
	<omniUnenforced>
	^ obj nextPut: val! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/29/2013 13:08'!
external_primReplaceFrom: start to: stop with: replacement startingAt: repStart on: obj
	<omniUnenforced>
	^ obj replaceFrom: start to: stop with: replacement startingAt: repStart! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/29/2013 13:08'!
external_primShallowCopy: anObj
	<omniUnenforced>
	^ anObj shallowCopy! !

!OstDomain methodsFor: 'omni handlers external' stamp: 'StefanMarr 1/29/2013 16:47'!
external_readField: idx of: obj
	<omniUnenforced>
	^ obj instVarAt: idx! !

!OstDomain methodsFor: 'omni handlers external' stamp: 'StefanMarr 1/29/2013 16:47'!
external_readLiteral: association
	<omniUnenforced>
	^ association value! !

!OstDomain methodsFor: 'omni handlers external' stamp: 'StefanMarr 1/29/2013 16:47'!
external_requestExecution: p1 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1! !

!OstDomain methodsFor: 'omni handlers external' stamp: 'StefanMarr 1/29/2013 16:47'!
external_requestExecution: p1 with: p2 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2! !

!OstDomain methodsFor: 'omni handlers external' stamp: 'StefanMarr 1/29/2013 16:47'!
external_requestExecution: p1 with: p2 with: p3 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3! !

!OstDomain methodsFor: 'omni handlers external' stamp: 'StefanMarr 1/29/2013 16:46'!
external_requestExecution: p1 with: p2 with: p3 with: p4 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4! !

!OstDomain methodsFor: 'omni handlers external' stamp: 'StefanMarr 1/29/2013 16:46'!
external_requestExecution: p1 with: p2 with: p3 with: p4 with: p5 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5! !

!OstDomain methodsFor: 'omni handlers external' stamp: 'StefanMarr 1/29/2013 16:46'!
external_requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6! !

!OstDomain methodsFor: 'omni handlers external' stamp: 'StefanMarr 1/29/2013 16:46'!
external_requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7! !

!OstDomain methodsFor: 'omni handlers external' stamp: 'StefanMarr 1/29/2013 16:46'!
external_requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8! !

!OstDomain methodsFor: 'omni handlers external' stamp: 'StefanMarr 1/29/2013 16:46'!
external_requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9! !

!OstDomain methodsFor: 'omni handlers external' stamp: 'StefanMarr 1/29/2013 16:46'!
external_requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10! !

!OstDomain methodsFor: 'omni handlers external' stamp: 'StefanMarr 1/29/2013 16:45'!
external_requestExecutionOf: aSelector lookup: cls on: anObject
	<omniUnenforced>
	^ anObject performSuper: aSelector inLookupClass: cls! !

!OstDomain methodsFor: 'omni handlers external' stamp: 'StefanMarr 1/29/2013 16:45'!
external_requestExecutionOf: aSelector lookup: cls on: anObject with: p1
	<omniUnenforced>
	^ anObject performSuper: aSelector with: { p1 } inLookupClass: cls.! !

!OstDomain methodsFor: 'omni handlers external' stamp: 'StefanMarr 1/29/2013 16:45'!
external_requestExecutionOf: aSelector lookup: cls on: anObject with: p1 with: p2
	<omniUnenforced>
	^ anObject performSuper: aSelector with: { p1. p2 } inLookupClass: cls.! !

!OstDomain methodsFor: 'omni handlers external' stamp: 'StefanMarr 1/29/2013 16:45'!
external_requestExecutionOf: aSelector lookup: cls on: anObject with: p1 with: p2 with: p3
	<omniUnenforced>
	^ anObject performSuper: aSelector with: { p1. p2. p3 } inLookupClass: cls.! !

!OstDomain methodsFor: 'omni handlers external' stamp: 'StefanMarr 1/29/2013 16:45'!
external_requestExecutionOf: aSelector lookup: cls on: anObject with: p1 with: p2 with: p3 with: p4
	<omniUnenforced>
	^ anObject performSuper: aSelector with: { p1. p2. p3. p4 } inLookupClass: cls.! !

!OstDomain methodsFor: 'omni handlers external' stamp: 'StefanMarr 1/29/2013 16:45'!
external_requestExecutionOf: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector! !

!OstDomain methodsFor: 'omni handlers external' stamp: 'StefanMarr 1/29/2013 16:45'!
external_write: val toField: idx of: obj
	<omniUnenforced>
	"The calling convention is to return val,
	 i.e., the value stored into the object field."
	obj instVarAt: idx put: val.
	^ val! !

!OstDomain methodsFor: 'omni handlers external' stamp: 'StefanMarr 1/29/2013 16:44'!
external_write: val toField: idx of: obj return: returnValue
	<omniUnenforced>
	"The calling convention is to return 'val,
	 i.e., the value stored into the object field.'returnValue',
	 always!! This is to support the variations of the
	 store-to-object-field bytecodes in the OmniVM."
	obj instVarAt: idx put: val.
	^ returnValue! !

!OstDomain methodsFor: 'omni handlers external' stamp: 'StefanMarr 1/29/2013 16:44'!
external_write: val toLiteral: association
	<omniUnenforced>
	^ association value: val! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/29/2013 13:07'!
internal_primAt: idx on: anObj
	<omniUnenforced>
	^ anObj at: idx! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/29/2013 13:15'!
internal_primAt: idx on: anObj put: aVal
	<omniUnenforced>
	^ anObj at: idx put: aVal! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/29/2013 13:15'!
internal_primBasicAt: idx on: anObj
	<omniUnenforced>
	^ anObj basicAt: idx! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/29/2013 13:15'!
internal_primBasicAt: idx on: anObj put: aVal
	<omniUnenforced>
	^ anObj basicAt: idx put: aVal! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/29/2013 13:15'!
internal_primInstVarAt: idx on: anObj
	<omniUnenforced>
	^ anObj instVarAt: idx! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/29/2013 13:15'!
internal_primInstVarAt: idx on: anObj put: aVal
	<omniUnenforced>
	^ anObj instVarAt: idx put: aVal! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/29/2013 13:15'!
internal_primNext: obj
	<omniUnenforced>
	^ obj next! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/29/2013 13:15'!
internal_primNext: obj put: val
	<omniUnenforced>
	^ obj nextPut: val! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/29/2013 13:14'!
internal_primReplaceFrom: start to: stop with: replacement startingAt: repStart on: obj
	<omniUnenforced>
	^ obj replaceFrom: start to: stop with: replacement startingAt: repStart! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/29/2013 13:14'!
internal_primShallowCopy: anObj
	<omniUnenforced>
	^ anObj shallowCopy! !

!OstDomain methodsFor: 'omni handlers internal' stamp: 'StefanMarr 1/29/2013 16:50'!
internal_readField: idx of: obj
	<omniUnenforced>
	^ obj instVarAt: idx! !

!OstDomain methodsFor: 'omni handlers internal' stamp: 'StefanMarr 1/29/2013 16:50'!
internal_readLiteral: association
	<omniUnenforced>
	^ association value! !

!OstDomain methodsFor: 'omni handlers internal' stamp: 'StefanMarr 1/29/2013 16:51'!
internal_requestExecution: p1 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1! !

!OstDomain methodsFor: 'omni handlers internal' stamp: 'StefanMarr 1/29/2013 16:51'!
internal_requestExecution: p1 with: p2 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2! !

!OstDomain methodsFor: 'omni handlers internal' stamp: 'StefanMarr 1/29/2013 16:51'!
internal_requestExecution: p1 with: p2 with: p3 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3! !

!OstDomain methodsFor: 'omni handlers internal' stamp: 'StefanMarr 1/29/2013 16:52'!
internal_requestExecution: p1 with: p2 with: p3 with: p4 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4! !

!OstDomain methodsFor: 'omni handlers internal' stamp: 'StefanMarr 1/29/2013 16:52'!
internal_requestExecution: p1 with: p2 with: p3 with: p4 with: p5 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5! !

!OstDomain methodsFor: 'omni handlers internal' stamp: 'StefanMarr 1/29/2013 16:52'!
internal_requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6! !

!OstDomain methodsFor: 'omni handlers internal' stamp: 'StefanMarr 1/29/2013 16:52'!
internal_requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7! !

!OstDomain methodsFor: 'omni handlers internal' stamp: 'StefanMarr 1/29/2013 16:52'!
internal_requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8! !

!OstDomain methodsFor: 'omni handlers internal' stamp: 'StefanMarr 1/29/2013 16:52'!
internal_requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9! !

!OstDomain methodsFor: 'omni handlers internal' stamp: 'StefanMarr 1/29/2013 16:52'!
internal_requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10! !

!OstDomain methodsFor: 'omni handlers internal' stamp: 'StefanMarr 1/29/2013 16:52'!
internal_requestExecutionOf: aSelector lookup: cls on: anObject
	<omniUnenforced>
	^ anObject performSuper: aSelector inLookupClass: cls! !

!OstDomain methodsFor: 'omni handlers internal' stamp: 'StefanMarr 1/29/2013 16:53'!
internal_requestExecutionOf: aSelector lookup: cls on: anObject with: p1
	<omniUnenforced>
	^ anObject performSuper: aSelector with: { p1 } inLookupClass: cls.! !

!OstDomain methodsFor: 'omni handlers internal' stamp: 'StefanMarr 1/29/2013 16:53'!
internal_requestExecutionOf: aSelector lookup: cls on: anObject with: p1 with: p2
	<omniUnenforced>
	^ anObject performSuper: aSelector with: { p1. p2 } inLookupClass: cls.! !

!OstDomain methodsFor: 'omni handlers internal' stamp: 'StefanMarr 1/29/2013 16:53'!
internal_requestExecutionOf: aSelector lookup: cls on: anObject with: p1 with: p2 with: p3
	<omniUnenforced>
	^ anObject performSuper: aSelector with: { p1. p2. p3 } inLookupClass: cls.! !

!OstDomain methodsFor: 'omni handlers internal' stamp: 'StefanMarr 1/29/2013 16:50'!
internal_requestExecutionOf: aSelector lookup: cls on: anObject with: p1 with: p2 with: p3 with: p4
	<omniUnenforced>
	^ anObject performSuper: aSelector with: { p1. p2. p3. p4 } inLookupClass: cls.! !

!OstDomain methodsFor: 'omni handlers internal' stamp: 'StefanMarr 1/29/2013 16:50'!
internal_requestExecutionOf: aSelector on: anObject
	<omniUnenforced>
	^ anObject perform: aSelector! !

!OstDomain methodsFor: 'omni handlers internal' stamp: 'StefanMarr 1/29/2013 16:50'!
internal_write: val toField: idx of: obj
	<omniUnenforced>
	"The calling convention is to return val,
	 i.e., the value stored into the object field."
	obj instVarAt: idx put: val.
	^ val! !

!OstDomain methodsFor: 'omni handlers internal' stamp: 'StefanMarr 1/29/2013 16:50'!
internal_write: val toField: idx of: obj return: returnValue
	<omniUnenforced>
	"The calling convention is to return 'val,
	 i.e., the value stored into the object field.'returnValue',
	 always!! This is to support the variations of the
	 store-to-object-field bytecodes in the OmniVM."
	obj instVarAt: idx put: val.
	^ returnValue! !

!OstDomain methodsFor: 'omni handlers internal' stamp: 'StefanMarr 1/29/2013 16:50'!
internal_write: val toLiteral: association
	<omniUnenforced>
	^ association value: val! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 12/11/2011 20:05'!
newProcessFor: aBlock
	"Answer a Process running the code in aBlock in this domain.
	 The process is not scheduled."
	| ctx proc |
	<primitive: 19> "Simulation guard"
	ctx := [aBlock value.
			Processor terminateActive] asContext.
	proc := Process
		forContext: ctx
		priority: Processor activePriority.
	proc omniDomain: self.
	^ proc.! !

!OstDomain methodsFor: 'OmniST delegation' stamp: 'StefanMarr 1/30/2013 11:21'!
readField: idx of: obj
	Processor activeProcess omniDomain == self
	  ifTrue:  [ ^ self internal_readField: idx of: obj ]
	  ifFalse: [ ^ self external_readField: idx of: obj ]! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 12/8/2011 14:07'!
spawnHere: aBlock
	"Spawn the given block as a process in this domain"
	
	self flag: 'WARNING: copied from ODomain.
	TODO: fix later after abstracting concepts from the results of the experiments.'.
	
	^ (self newProcessFor: aBlock) resume! !

!OstDomain methodsFor: 'OmniST delegation' stamp: 'StefanMarr 1/30/2013 11:20'!
write: val toField: idx of: obj
	Processor activeProcess omniDomain == self
	  ifTrue:  [ ^ self internal_write: val toField: idx of: obj ]
	  ifFalse: [ ^ self external_write: val toField: idx of: obj ]! !

!OstObject class methodsFor: 'initialization' stamp: 'StefanMarr 1/6/2012 00:56'!
initialize
	"Here we will need something to bring our OstDomain like properties, for instance as a trait to at least some of the stream classes"! !

!OstObject class methodsFor: 'omnify' stamp: 'StefanMarr 7/18/2012 22:50'!
omnifyClass: aClass
	"First add all inst vars"
	self instVarNames do: [:varName | 
		(aClass hasInstVarNamed: varName) ifFalse: [
			aClass addInstVarNamed: varName]].
	
	"Then copy the methods"
	(self organization listAtCategoryNamed: 'omni reflection') do: [:selector |
		| method |
		method := self lookupSelector: selector.
		aClass compile: method getSourceFromFile
		       classified: method category
		       withStamp: method timeStamp
		       notifying: nil
		       logSource: true.
	].! !

!OstObject class methodsFor: 'initialize-release' stamp: 'StefanMarr 1/4/2012 15:22'!
unload
	"Revert changes"
	
	Stream superclass: Object.! !

!OstObject methodsFor: 'omni reflection' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstObject methodsFor: 'omni reflection' stamp: 'StefanMarr 1/3/2012 14:04'!
omniDomain: aDomain
	omniDomain := aDomain! !

!OstObject methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector on: self. ]
	! !

!OstObject methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector lookup: cls
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector lookup: cls on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector lookup: cls on: self. ]
	! !

!OstObject methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 of: aSelector on: self ]! !

!OstObject methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1 with: p2
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 with: p2 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 with: p2 of: aSelector on: self ]! !

!OstObject methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
		! !

!OstObject methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]! !

!OstObject methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]! !

!OstObject methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]! !

!OstObject methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]! !

!OstObject methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]! !

!OstObject methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]! !

!OstObject methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]! !

!RBLexicalScope methodsFor: '*OmniST-Core-Compiler' stamp: 'StefanMarr 12/9/2011 15:20'!
numOmniTemps
	^ (bindings keys select: [:name | name beginsWith: 'x_omni_']) size! !
OstPoint initialize!
OstSet initialize!
OstOrderedCollection initialize!
OstDictionary initialize!
OstCompiler initialize!
OstIdentityDictionary initialize!
OstMonitor initialize!
OstAssociation initialize!
OstRectangle initialize!
OstInterval initialize!
OstObject initialize!
OstSharedQueue initialize!
OstTestCase initialize!
OstDomain initialize!
OstTransformer initialize!
OstSortedCollection initialize!
OstArray initialize!
OPromise initialize!
